/* ***********************************************************
 * This file was automatically generated on 2019-09-13.      *
 *                                                           *
 * OpenHAB Bindings Version 2.1.23                           *
 *                                                           *
 * If you have a bugfix for this file and want to commit it, *
 * please fix the bug in the generator. You can find a link  *
 * to the generators git repository on tinkerforge.com       *
 *************************************************************/

package com.tinkerforge;

import java.nio.ByteBuffer;
import java.nio.ByteOrder;
import java.util.concurrent.CopyOnWriteArrayList;
import java.util.Arrays;
import java.util.List;
import java.net.URI;
import java.math.BigDecimal;
import java.util.ArrayList;
import java.util.Collections;
import java.util.function.Function;
import java.util.function.BiConsumer;
import org.eclipse.smarthome.config.core.Configuration;
import org.eclipse.smarthome.config.core.ConfigDescription;
import org.eclipse.smarthome.config.core.ConfigDescriptionParameter.Type;
import org.eclipse.smarthome.config.core.ConfigDescriptionParameterBuilder;
import org.eclipse.smarthome.config.core.ConfigDescriptionParameterGroup;
import org.eclipse.smarthome.config.core.ParameterOption;
import org.eclipse.smarthome.core.types.State;
import org.eclipse.smarthome.core.types.StateOption;
import org.eclipse.smarthome.core.types.Command;
import org.eclipse.smarthome.core.types.CommandDescriptionBuilder;
import org.eclipse.smarthome.core.types.CommandOption;
import org.eclipse.smarthome.core.thing.ThingTypeUID;
import org.eclipse.smarthome.core.thing.type.ChannelDefinitionBuilder;
import org.eclipse.smarthome.core.thing.type.ChannelType;
import org.eclipse.smarthome.core.thing.type.ChannelTypeBuilder;
import org.eclipse.smarthome.core.thing.type.ChannelTypeUID;
import org.eclipse.smarthome.core.thing.type.ThingType;
import org.eclipse.smarthome.core.thing.type.ThingTypeBuilder;
import org.eclipse.smarthome.core.types.StateDescriptionFragmentBuilder;
import org.eclipse.smarthome.binding.tinkerforge.internal.TinkerforgeBindingConstants;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.eclipse.smarthome.core.library.types.QuantityType;
import org.eclipse.smarthome.core.library.unit.MetricPrefix;
import org.eclipse.smarthome.core.library.unit.SIUnits;
import org.eclipse.smarthome.core.library.unit.SmartHomeUnits;
import org.eclipse.smarthome.core.library.types.OnOffType;
import org.eclipse.smarthome.core.library.types.StringType;

/**
 * 4-channel digital input/output
 */
public class BrickletIO4 extends Device {
	public final static int DEVICE_IDENTIFIER = 29;
	public final static String DEVICE_DISPLAY_NAME = "IO-4 Bricklet";

    public final static DeviceInfo DEVICE_INFO = new DeviceInfo(DEVICE_DISPLAY_NAME, "io4", DEVICE_IDENTIFIER, BrickletIO4.class);

	public final static byte FUNCTION_SET_VALUE = (byte)1;
	public final static byte FUNCTION_GET_VALUE = (byte)2;
	public final static byte FUNCTION_SET_CONFIGURATION = (byte)3;
	public final static byte FUNCTION_GET_CONFIGURATION = (byte)4;
	public final static byte FUNCTION_SET_DEBOUNCE_PERIOD = (byte)5;
	public final static byte FUNCTION_GET_DEBOUNCE_PERIOD = (byte)6;
	public final static byte FUNCTION_SET_INTERRUPT = (byte)7;
	public final static byte FUNCTION_GET_INTERRUPT = (byte)8;
	public final static byte FUNCTION_SET_MONOFLOP = (byte)10;
	public final static byte FUNCTION_GET_MONOFLOP = (byte)11;
	public final static byte FUNCTION_SET_SELECTED_VALUES = (byte)13;
	public final static byte FUNCTION_GET_EDGE_COUNT = (byte)14;
	public final static byte FUNCTION_SET_EDGE_COUNT_CONFIG = (byte)15;
	public final static byte FUNCTION_GET_EDGE_COUNT_CONFIG = (byte)16;
	public final static byte FUNCTION_GET_IDENTITY = (byte)255;
	private final static int CALLBACK_INTERRUPT = 9;
	private final static int CALLBACK_MONOFLOP_DONE = 12;

	public final static char DIRECTION_IN = 'i';
	public final static char DIRECTION_OUT = 'o';
	public final static short EDGE_TYPE_RISING = (short)0;
	public final static short EDGE_TYPE_FALLING = (short)1;
	public final static short EDGE_TYPE_BOTH = (short)2;

	private List<InterruptListener> listenerInterrupt = new CopyOnWriteArrayList<InterruptListener>();
	private List<MonoflopDoneListener> listenerMonoflopDone = new CopyOnWriteArrayList<MonoflopDoneListener>();

	public class Configuration {
		public short directionMask;
		public short valueMask;

		public String toString() {
			return "[" + "directionMask = " + directionMask + ", " + "valueMask = " + valueMask + "]";
		}
	}

	public class Monoflop {
		public short value;
		public long time;
		public long timeRemaining;

		public String toString() {
			return "[" + "value = " + value + ", " + "time = " + time + ", " + "timeRemaining = " + timeRemaining + "]";
		}
	}

	public class EdgeCountConfig {
		public short edgeType;
		public short debounce;

		public String toString() {
			return "[" + "edgeType = " + edgeType + ", " + "debounce = " + debounce + "]";
		}
	}

	/**
	 * This listener is triggered whenever a change of the voltage level is detected
	 * on pins where the interrupt was activated with {@link BrickletIO4#setInterrupt(short)}.
	 * 
	 * The values are a bitmask that specifies which interrupts occurred
	 * and the current value bitmask.
	 * 
	 * For example:
	 * 
	 * * (1, 1) or (0b0001, 0b0001) means that an interrupt on pin 0 occurred and
	 *   currently pin 0 is high and pins 1-3 are low.
	 * * (9, 14) or (0b1001, 0b1110) means that interrupts on pins 0 and 3
	 *   occurred and currently pin 0 is low and pins 1-3 are high.
	 */
	public interface InterruptListener extends DeviceListener {
		public void interrupt(short interruptMask, short valueMask);
	}

	/**
	 * This listener is triggered whenever a monoflop timer reaches 0. The
	 * parameters contain the involved pins and the current value of the pins
	 * (the value after the monoflop).
	 */
	public interface MonoflopDoneListener extends DeviceListener {
		public void monoflopDone(short selectionMask, short valueMask);
	}

	/**
	 * Creates an object with the unique device ID \c uid. and adds it to
	 * the IP Connection \c ipcon.
	 */
	public BrickletIO4(String uid, IPConnection ipcon) {
		super(uid, ipcon);

		apiVersion[0] = 2;
		apiVersion[1] = 0;
		apiVersion[2] = 1;
		responseExpected[IPConnection.unsignedByte(FUNCTION_SET_VALUE)] = RESPONSE_EXPECTED_FLAG_FALSE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_GET_VALUE)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_SET_CONFIGURATION)] = RESPONSE_EXPECTED_FLAG_FALSE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_GET_CONFIGURATION)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_SET_DEBOUNCE_PERIOD)] = RESPONSE_EXPECTED_FLAG_TRUE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_GET_DEBOUNCE_PERIOD)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_SET_INTERRUPT)] = RESPONSE_EXPECTED_FLAG_TRUE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_GET_INTERRUPT)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_SET_MONOFLOP)] = RESPONSE_EXPECTED_FLAG_FALSE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_GET_MONOFLOP)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_SET_SELECTED_VALUES)] = RESPONSE_EXPECTED_FLAG_FALSE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_GET_EDGE_COUNT)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_SET_EDGE_COUNT_CONFIG)] = RESPONSE_EXPECTED_FLAG_FALSE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_GET_EDGE_COUNT_CONFIG)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_GET_IDENTITY)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;

		callbacks[CALLBACK_INTERRUPT] = new IPConnection.DeviceCallbackListener() {
			public void callback(byte[] packet) {
				ByteBuffer bb = ByteBuffer.wrap(packet, 8, packet.length - 8);
				bb.order(ByteOrder.LITTLE_ENDIAN);

				short interruptMask = IPConnection.unsignedByte(bb.get());
				short valueMask = IPConnection.unsignedByte(bb.get());

				for (InterruptListener listener: listenerInterrupt) {
					listener.interrupt(interruptMask, valueMask);
				}
			}
		};

		callbacks[CALLBACK_MONOFLOP_DONE] = new IPConnection.DeviceCallbackListener() {
			public void callback(byte[] packet) {
				ByteBuffer bb = ByteBuffer.wrap(packet, 8, packet.length - 8);
				bb.order(ByteOrder.LITTLE_ENDIAN);

				short selectionMask = IPConnection.unsignedByte(bb.get());
				short valueMask = IPConnection.unsignedByte(bb.get());

				for (MonoflopDoneListener listener: listenerMonoflopDone) {
					listener.monoflopDone(selectionMask, valueMask);
				}
			}
		};
	}

	/**
	 * Sets the output value (high or low) with a bitmask (4bit). A 1 in the bitmask
	 * means high and a 0 in the bitmask means low.
	 * 
	 * For example: The value 3 or 0b0011 will turn the pins 0-1 high and the
	 * pins 2-3 low.
	 * 
	 * All running monoflop timers will be aborted if this function is called.
	 * 
	 * \note
	 *  This function does nothing for pins that are configured as input.
	 *  Pull-up resistors can be switched on with {@link BrickletIO4#setConfiguration(short, char, boolean)}.
	 */
	public void setValue(short valueMask) throws TinkerforgeException {
		ByteBuffer bb = ipcon.createRequestPacket((byte)9, FUNCTION_SET_VALUE, this);

		bb.put((byte)valueMask);

		sendRequest(bb.array());
	}

	/**
	 * Returns a bitmask of the values that are currently measured.
	 * This function works if the pin is configured to input
	 * as well as if it is configured to output.
	 */
	public short getValue() throws TinkerforgeException {
		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_VALUE, this);


		byte[] response = sendRequest(bb.array());

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		short valueMask = IPConnection.unsignedByte(bb.get());

		return valueMask;
	}

	/**
	 * Configures the value and direction of the specified pins. Possible directions
	 * are 'i' and 'o' for input and output.
	 * 
	 * If the direction is configured as output, the value is either high or low
	 * (set as *true* or *false*).
	 * 
	 * If the direction is configured as input, the value is either pull-up or
	 * default (set as *true* or *false*).
	 * 
	 * For example:
	 * 
	 * * (15, 'i', true) or (0b1111, 'i', true) will set all pins of as input pull-up.
	 * * (8, 'i', false) or (0b1000, 'i', false) will set pin 3 of as input default (floating if nothing is connected).
	 * * (3, 'o', false) or (0b0011, 'o', false) will set pins 0 and 1 as output low.
	 * * (4, 'o', true) or (0b0100, 'o', true) will set pin 2 of as output high.
	 * 
	 * Running monoflop timers for the specified pins will be aborted if this
	 * function is called.
	 * 
	 * The default configuration is input with pull-up.
	 */
	public void setConfiguration(short selectionMask, char direction, boolean value) throws TinkerforgeException {
		ByteBuffer bb = ipcon.createRequestPacket((byte)11, FUNCTION_SET_CONFIGURATION, this);

		bb.put((byte)selectionMask);
		bb.put((byte)direction);
		bb.put((byte)(value ? 1 : 0));

		sendRequest(bb.array());
	}

	/**
	 * Returns a value bitmask and a direction bitmask. A 1 in the direction bitmask
	 * means input and a 0 in the bitmask means output.
	 * 
	 * For example: A return value of (3, 5) or (0b0011, 0b0101) for direction and
	 * value means that:
	 * 
	 * * pin 0 is configured as input pull-up,
	 * * pin 1 is configured as input default,
	 * * pin 2 is configured as output high and
	 * * pin 3 is are configured as output low.
	 */
	public Configuration getConfiguration() throws TinkerforgeException {
		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_CONFIGURATION, this);


		byte[] response = sendRequest(bb.array());

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		Configuration obj = new Configuration();
		obj.directionMask = IPConnection.unsignedByte(bb.get());
		obj.valueMask = IPConnection.unsignedByte(bb.get());

		return obj;
	}

	/**
	 * Sets the debounce period of the {@link BrickletIO4.InterruptListener} listener in ms.
	 * 
	 * For example: If you set this value to 100, you will get the interrupt
	 * maximal every 100ms. This is necessary if something that bounces is
	 * connected to the IO-4 Bricklet, such as a button.
	 * 
	 * The default value is 100.
	 */
	public void setDebouncePeriod(long debounce) throws TinkerforgeException {
		ByteBuffer bb = ipcon.createRequestPacket((byte)12, FUNCTION_SET_DEBOUNCE_PERIOD, this);

		bb.putInt((int)debounce);

		sendRequest(bb.array());
	}

	/**
	 * Returns the debounce period as set by {@link BrickletIO4#setDebouncePeriod(long)}.
	 */
	public long getDebouncePeriod() throws TinkerforgeException {
		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_DEBOUNCE_PERIOD, this);


		byte[] response = sendRequest(bb.array());

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		long debounce = IPConnection.unsignedInt(bb.getInt());

		return debounce;
	}

	/**
	 * Sets the pins on which an interrupt is activated with a bitmask.
	 * Interrupts are triggered on changes of the voltage level of the pin,
	 * i.e. changes from high to low and low to high.
	 * 
	 * For example: An interrupt bitmask of 10 or 0b1010 will enable the interrupt for
	 * pins 1 and 3.
	 * 
	 * The interrupt is delivered with the {@link BrickletIO4.InterruptListener} listener.
	 */
	public void setInterrupt(short interruptMask) throws TinkerforgeException {
		ByteBuffer bb = ipcon.createRequestPacket((byte)9, FUNCTION_SET_INTERRUPT, this);

		bb.put((byte)interruptMask);

		sendRequest(bb.array());
	}

	/**
	 * Returns the interrupt bitmask as set by {@link BrickletIO4#setInterrupt(short)}.
	 */
	public short getInterrupt() throws TinkerforgeException {
		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_INTERRUPT, this);


		byte[] response = sendRequest(bb.array());

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		short interruptMask = IPConnection.unsignedByte(bb.get());

		return interruptMask;
	}

	/**
	 * Configures a monoflop of the pins specified by the first parameter as 4 bit
	 * long bitmask. The specified pins must be configured for output. Non-output
	 * pins will be ignored.
	 * 
	 * The second parameter is a bitmask with the desired value of the specified
	 * output pins. A 1 in the bitmask means high and a 0 in the bitmask means low.
	 * 
	 * The third parameter indicates the time (in ms) that the pins should hold
	 * the value.
	 * 
	 * If this function is called with the parameters (9, 1, 1500) or
	 * (0b1001, 0b0001, 1500): Pin 0 will get high and pin 3 will get low. In 1.5s pin
	 * 0 will get low and pin 3 will get high again.
	 * 
	 * A monoflop can be used as a fail-safe mechanism. For example: Lets assume you
	 * have a RS485 bus and an IO-4 Bricklet connected to one of the slave
	 * stacks. You can now call this function every second, with a time parameter
	 * of two seconds and pin 0 set to high. Pin 0 will be high all the time. If now
	 * the RS485 connection is lost, then pin 0 will get low in at most two seconds.
	 */
	public void setMonoflop(short selectionMask, short valueMask, long time) throws TinkerforgeException {
		ByteBuffer bb = ipcon.createRequestPacket((byte)14, FUNCTION_SET_MONOFLOP, this);

		bb.put((byte)selectionMask);
		bb.put((byte)valueMask);
		bb.putInt((int)time);

		sendRequest(bb.array());
	}

	/**
	 * Returns (for the given pin) the current value and the time as set by
	 * {@link BrickletIO4#setMonoflop(short, short, long)} as well as the remaining time until the value flips.
	 * 
	 * If the timer is not running currently, the remaining time will be returned
	 * as 0.
	 */
	public Monoflop getMonoflop(short pin) throws TinkerforgeException {
		ByteBuffer bb = ipcon.createRequestPacket((byte)9, FUNCTION_GET_MONOFLOP, this);

		bb.put((byte)pin);

		byte[] response = sendRequest(bb.array());

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		Monoflop obj = new Monoflop();
		obj.value = IPConnection.unsignedByte(bb.get());
		obj.time = IPConnection.unsignedInt(bb.getInt());
		obj.timeRemaining = IPConnection.unsignedInt(bb.getInt());

		return obj;
	}

	/**
	 * Sets the output value (high or low) with a bitmask, according to
	 * the selection mask. The bitmask is 4 bit long, *true* refers to high
	 * and *false* refers to low.
	 * 
	 * For example: The parameters (9, 4) or (0b0110, 0b0100) will turn
	 * pin 1 low and pin 2 high, pin 0 and 3 will remain untouched.
	 * 
	 * Running monoflop timers for the selected pins will be aborted if this
	 * function is called.
	 * 
	 * \note
	 *  This function does nothing for pins that are configured as input.
	 *  Pull-up resistors can be switched on with {@link BrickletIO4#setConfiguration(short, char, boolean)}.
	 */
	public void setSelectedValues(short selectionMask, short valueMask) throws TinkerforgeException {
		ByteBuffer bb = ipcon.createRequestPacket((byte)10, FUNCTION_SET_SELECTED_VALUES, this);

		bb.put((byte)selectionMask);
		bb.put((byte)valueMask);

		sendRequest(bb.array());
	}

	/**
	 * Returns the current value of the edge counter for the selected pin. You can
	 * configure the edges that are counted with {@link BrickletIO4#setEdgeCountConfig(short, short, short)}.
	 * 
	 * If you set the reset counter to *true*, the count is set back to 0
	 * directly after it is read.
	 * 
	 * .. versionadded:: 2.0.1$nbsp;(Plugin)
	 */
	public long getEdgeCount(short pin, boolean resetCounter) throws TinkerforgeException {
		ByteBuffer bb = ipcon.createRequestPacket((byte)10, FUNCTION_GET_EDGE_COUNT, this);

		bb.put((byte)pin);
		bb.put((byte)(resetCounter ? 1 : 0));

		byte[] response = sendRequest(bb.array());

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		long count = IPConnection.unsignedInt(bb.getInt());

		return count;
	}

	/**
	 * Configures the edge counter for the selected pins.
	 * 
	 * The edge type parameter configures if rising edges, falling edges or
	 * both are counted if the pin is configured for input. Possible edge types are:
	 * 
	 * * 0 = rising (default)
	 * * 1 = falling
	 * * 2 = both
	 * 
	 * The debounce time is given in ms.
	 * 
	 * Configuring an edge counter resets its value to 0.
	 * 
	 * If you don't know what any of this means, just leave it at default. The
	 * default configuration is very likely OK for you.
	 * 
	 * Default values: 0 (edge type) and 100ms (debounce time)
	 * 
	 * .. versionadded:: 2.0.1$nbsp;(Plugin)
	 */
	public void setEdgeCountConfig(short selectionMask, short edgeType, short debounce) throws TinkerforgeException {
		ByteBuffer bb = ipcon.createRequestPacket((byte)11, FUNCTION_SET_EDGE_COUNT_CONFIG, this);

		bb.put((byte)selectionMask);
		bb.put((byte)edgeType);
		bb.put((byte)debounce);

		sendRequest(bb.array());
	}

	/**
	 * Returns the edge type and debounce time for the selected pin as set by
	 * {@link BrickletIO4#setEdgeCountConfig(short, short, short)}.
	 * 
	 * .. versionadded:: 2.0.1$nbsp;(Plugin)
	 */
	public EdgeCountConfig getEdgeCountConfig(short pin) throws TinkerforgeException {
		ByteBuffer bb = ipcon.createRequestPacket((byte)9, FUNCTION_GET_EDGE_COUNT_CONFIG, this);

		bb.put((byte)pin);

		byte[] response = sendRequest(bb.array());

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		EdgeCountConfig obj = new EdgeCountConfig();
		obj.edgeType = IPConnection.unsignedByte(bb.get());
		obj.debounce = IPConnection.unsignedByte(bb.get());

		return obj;
	}

	/**
	 * Returns the UID, the UID where the Bricklet is connected to,
	 * the position, the hardware and firmware version as well as the
	 * device identifier.
	 * 
	 * The position can be 'a', 'b', 'c' or 'd'.
	 * 
	 * The device identifier numbers can be found :ref:`here &lt;device_identifier&gt;`.
	 * |device_identifier_constant|
	 */
	public Identity getIdentity() throws TinkerforgeException {
		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_IDENTITY, this);


		byte[] response = sendRequest(bb.array());

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		Identity obj = new Identity();
		obj.uid = IPConnection.string(bb, 8);
		obj.connectedUid = IPConnection.string(bb, 8);
		obj.position = (char)(bb.get());
		for (int i = 0; i < 3; i++) {
			obj.hardwareVersion[i] = IPConnection.unsignedByte(bb.get());
		}
		for (int i = 0; i < 3; i++) {
			obj.firmwareVersion[i] = IPConnection.unsignedByte(bb.get());
		}
		obj.deviceIdentifier = IPConnection.unsignedShort(bb.getShort());

		return obj;
	}

	/**
	 * Adds a Interrupt listener.
	 */
	public void addInterruptListener(InterruptListener listener) {
		listenerInterrupt.add(listener);
	}

	/**
	 * Removes a Interrupt listener.
	 */
	public void removeInterruptListener(InterruptListener listener) {
		listenerInterrupt.remove(listener);
	}

	/**
	 * Adds a MonoflopDone listener.
	 */
	public void addMonoflopDoneListener(MonoflopDoneListener listener) {
		listenerMonoflopDone.add(listener);
	}

	/**
	 * Removes a MonoflopDone listener.
	 */
	public void removeMonoflopDoneListener(MonoflopDoneListener listener) {
		listenerMonoflopDone.remove(listener);
	}

    private final Logger logger = LoggerFactory.getLogger(BrickletIO4.class);
    private final static Logger static_logger = LoggerFactory.getLogger(BrickletIO4.class);

    @Override
    public void initialize(org.eclipse.smarthome.config.core.Configuration config, Function<String, org.eclipse.smarthome.config.core.Configuration> getChannelConfigFn, BiConsumer<String, org.eclipse.smarthome.core.types.State> updateStateFn, BiConsumer<String, String> triggerChannelFn) throws TinkerforgeException {
        BrickletIO4Config cfg = (BrickletIO4Config) config.as(BrickletIO4Config.class);
        this.addInterruptListener((interruptMask, valueMask) -> {if((interruptMask & (1 << 0)) > 0) {updateStateFn.accept("IO4InputPin0", transformIO4InputPin0Callback0(interruptMask, valueMask, cfg));}});
		this.addInterruptListener((interruptMask, valueMask) -> {if((interruptMask & (1 << 1)) > 0) {updateStateFn.accept("IO4InputPin1", transformIO4InputPin1Callback0(interruptMask, valueMask, cfg));}});
		this.addInterruptListener((interruptMask, valueMask) -> {if((interruptMask & (1 << 2)) > 0) {updateStateFn.accept("IO4InputPin2", transformIO4InputPin2Callback0(interruptMask, valueMask, cfg));}});
		this.addInterruptListener((interruptMask, valueMask) -> {if((interruptMask & (1 << 3)) > 0) {updateStateFn.accept("IO4InputPin3", transformIO4InputPin3Callback0(interruptMask, valueMask, cfg));}});
		this.addMonoflopDoneListener((selectionMask, valueMask) -> {if((selectionMask & (1 << 0)) > 0) {updateStateFn.accept("IO4OutputPin0", transformIO4OutputPin0Callback0(selectionMask, valueMask, cfg));}});
		this.addMonoflopDoneListener((selectionMask, valueMask) -> {if((selectionMask & (1 << 1)) > 0) {updateStateFn.accept("IO4OutputPin1", transformIO4OutputPin1Callback0(selectionMask, valueMask, cfg));}});
		this.addMonoflopDoneListener((selectionMask, valueMask) -> {if((selectionMask & (1 << 2)) > 0) {updateStateFn.accept("IO4OutputPin2", transformIO4OutputPin2Callback0(selectionMask, valueMask, cfg));}});
		this.addMonoflopDoneListener((selectionMask, valueMask) -> {if((selectionMask & (1 << 3)) > 0) {updateStateFn.accept("IO4OutputPin3", transformIO4OutputPin3Callback0(selectionMask, valueMask, cfg));}});
        
		if (cfg.pinConfiguration0 > 1) {
		BrickletIO4InputPinConfig channelCfg = getChannelConfigFn.apply("IO4InputPin0").as(BrickletIO4InputPinConfig.class);
		this.setInterrupt((short)(this.getInterrupt() | (1 << 0)));
		            this.setConfiguration((short)(1 << 0), 'i', cfg.pinConfiguration0 % 2 == 1);
		}
		if (cfg.pinConfiguration1 > 1) {
		BrickletIO4InputPinConfig channelCfg = getChannelConfigFn.apply("IO4InputPin1").as(BrickletIO4InputPinConfig.class);
		this.setInterrupt((short)(this.getInterrupt() | (1 << 1)));
		            this.setConfiguration((short)(1 << 1), 'i', cfg.pinConfiguration1 % 2 == 1);
		}
		if (cfg.pinConfiguration2 > 1) {
		BrickletIO4InputPinConfig channelCfg = getChannelConfigFn.apply("IO4InputPin2").as(BrickletIO4InputPinConfig.class);
		this.setInterrupt((short)(this.getInterrupt() | (1 << 2)));
		            this.setConfiguration((short)(1 << 2), 'i', cfg.pinConfiguration2 % 2 == 1);
		}
		if (cfg.pinConfiguration3 > 1) {
		BrickletIO4InputPinConfig channelCfg = getChannelConfigFn.apply("IO4InputPin3").as(BrickletIO4InputPinConfig.class);
		this.setInterrupt((short)(this.getInterrupt() | (1 << 3)));
		            this.setConfiguration((short)(1 << 3), 'i', cfg.pinConfiguration3 % 2 == 1);
		}
		if (cfg.pinConfiguration0 <= 1) {
		BrickletIO4OutputPinConfig channelCfg = getChannelConfigFn.apply("IO4OutputPin0").as(BrickletIO4OutputPinConfig.class);
		this.setConfiguration((short)(1 << 0), 'o', cfg.pinConfiguration0 % 2 == 1);
		}
		if (cfg.pinConfiguration1 <= 1) {
		BrickletIO4OutputPinConfig channelCfg = getChannelConfigFn.apply("IO4OutputPin1").as(BrickletIO4OutputPinConfig.class);
		this.setConfiguration((short)(1 << 1), 'o', cfg.pinConfiguration1 % 2 == 1);
		}
		if (cfg.pinConfiguration2 <= 1) {
		BrickletIO4OutputPinConfig channelCfg = getChannelConfigFn.apply("IO4OutputPin2").as(BrickletIO4OutputPinConfig.class);
		this.setConfiguration((short)(1 << 2), 'o', cfg.pinConfiguration2 % 2 == 1);
		}
		if (cfg.pinConfiguration3 <= 1) {
		BrickletIO4OutputPinConfig channelCfg = getChannelConfigFn.apply("IO4OutputPin3").as(BrickletIO4OutputPinConfig.class);
		this.setConfiguration((short)(1 << 3), 'o', cfg.pinConfiguration3 % 2 == 1);
		}
		if (cfg.pinConfiguration0 <= 1) {
		BrickletIO4MonoflopConfig channelCfg = getChannelConfigFn.apply("IO4MonoflopPin0").as(BrickletIO4MonoflopConfig.class);
		
		}
		if (cfg.pinConfiguration1 <= 1) {
		BrickletIO4MonoflopConfig channelCfg = getChannelConfigFn.apply("IO4MonoflopPin1").as(BrickletIO4MonoflopConfig.class);
		
		}
		if (cfg.pinConfiguration2 <= 1) {
		BrickletIO4MonoflopConfig channelCfg = getChannelConfigFn.apply("IO4MonoflopPin2").as(BrickletIO4MonoflopConfig.class);
		
		}
		if (cfg.pinConfiguration3 <= 1) {
		BrickletIO4MonoflopConfig channelCfg = getChannelConfigFn.apply("IO4MonoflopPin3").as(BrickletIO4MonoflopConfig.class);
		
		}
		if (cfg.pinConfiguration0 > 1) {
		BrickletIO4EdgeCountConfig channelCfg = getChannelConfigFn.apply("IO4EdgeCountPin0").as(BrickletIO4EdgeCountConfig.class);
		this.setEdgeCountConfig((short)(1 << 0), channelCfg.edgeType.shortValue(), channelCfg.debounce.shortValue());
		}
		if (cfg.pinConfiguration1 > 1) {
		BrickletIO4EdgeCountConfig channelCfg = getChannelConfigFn.apply("IO4EdgeCountPin1").as(BrickletIO4EdgeCountConfig.class);
		this.setEdgeCountConfig((short)(1 << 1), channelCfg.edgeType.shortValue(), channelCfg.debounce.shortValue());
		}
		if (cfg.pinConfiguration2 > 1) {
		BrickletIO4EdgeCountConfig channelCfg = getChannelConfigFn.apply("IO4EdgeCountPin2").as(BrickletIO4EdgeCountConfig.class);
		this.setEdgeCountConfig((short)(1 << 2), channelCfg.edgeType.shortValue(), channelCfg.debounce.shortValue());
		}
		if (cfg.pinConfiguration3 > 1) {
		BrickletIO4EdgeCountConfig channelCfg = getChannelConfigFn.apply("IO4EdgeCountPin3").as(BrickletIO4EdgeCountConfig.class);
		this.setEdgeCountConfig((short)(1 << 3), channelCfg.edgeType.shortValue(), channelCfg.debounce.shortValue());
		}
    }

    @Override
    public void dispose(org.eclipse.smarthome.config.core.Configuration config) throws TinkerforgeException {
        BrickletIO4Config cfg = (BrickletIO4Config) config.as(BrickletIO4Config.class);
        this.listenerInterrupt.clear();
		this.listenerInterrupt.clear();
		this.listenerInterrupt.clear();
		this.listenerInterrupt.clear();
		this.listenerMonoflopDone.clear();
		this.listenerMonoflopDone.clear();
		this.listenerMonoflopDone.clear();
		this.listenerMonoflopDone.clear();
        this.setInterrupt((short)(this.getInterrupt() & ~(1 << 0)));
		this.setInterrupt((short)(this.getInterrupt() & ~(1 << 1)));
		this.setInterrupt((short)(this.getInterrupt() & ~(1 << 2)));
		this.setInterrupt((short)(this.getInterrupt() & ~(1 << 3)));
		
		
		
		
		
    }

    @Override
    public List<String> getEnabledChannels(org.eclipse.smarthome.config.core.Configuration config) throws TinkerforgeException{
        BrickletIO4Config cfg = (BrickletIO4Config) config.as(BrickletIO4Config.class);
        List<String> result = new ArrayList<String>();
        if (cfg.pinConfiguration0 > 1) {
                result.add("IO4InputPin0");
            }
		if (cfg.pinConfiguration1 > 1) {
                result.add("IO4InputPin1");
            }
		if (cfg.pinConfiguration2 > 1) {
                result.add("IO4InputPin2");
            }
		if (cfg.pinConfiguration3 > 1) {
                result.add("IO4InputPin3");
            }
		if (cfg.pinConfiguration0 <= 1) {
                result.add("IO4OutputPin0");
            }
		if (cfg.pinConfiguration1 <= 1) {
                result.add("IO4OutputPin1");
            }
		if (cfg.pinConfiguration2 <= 1) {
                result.add("IO4OutputPin2");
            }
		if (cfg.pinConfiguration3 <= 1) {
                result.add("IO4OutputPin3");
            }
		if (cfg.pinConfiguration0 <= 1) {
                result.add("IO4MonoflopPin0");
            }
		if (cfg.pinConfiguration1 <= 1) {
                result.add("IO4MonoflopPin1");
            }
		if (cfg.pinConfiguration2 <= 1) {
                result.add("IO4MonoflopPin2");
            }
		if (cfg.pinConfiguration3 <= 1) {
                result.add("IO4MonoflopPin3");
            }
		if (cfg.pinConfiguration0 > 1) {
                result.add("IO4EdgeCountPin0");
            }
		if (cfg.pinConfiguration1 > 1) {
                result.add("IO4EdgeCountPin1");
            }
		if (cfg.pinConfiguration2 > 1) {
                result.add("IO4EdgeCountPin2");
            }
		if (cfg.pinConfiguration3 > 1) {
                result.add("IO4EdgeCountPin3");
            }
        return result;
    }

    public static ChannelType getChannelType(ChannelTypeUID channelTypeUID) {
        switch(channelTypeUID.getId()) {
            case "IO4InputPin":
                return ChannelTypeBuilder.state(new ChannelTypeUID("tinkerforge", "IO4InputPin"), "Measured Level", "Switch").withConfigDescriptionURI(URI.create("channel-type:tinkerforge:IO4InputPin")).withDescription("The logic level that is currently measured on the pin.")
.withStateDescription(StateDescriptionFragmentBuilder.create().withReadOnly(true).build().toStateDescription()).build();
            case "IO4OutputPin":
                return ChannelTypeBuilder.state(new ChannelTypeUID("tinkerforge", "IO4OutputPin"), "Set Level", "Switch").withConfigDescriptionURI(URI.create("channel-type:tinkerforge:IO4OutputPin")).withDescription("The logic level that is currently set on the pin.")
.withStateDescription(StateDescriptionFragmentBuilder.create().withReadOnly(false).build().toStateDescription()).build();
            case "IO4Monoflop":
                return ChannelTypeBuilder.state(new ChannelTypeUID("tinkerforge", "IO4Monoflop"), "NOT USED", "String").withConfigDescriptionURI(URI.create("channel-type:tinkerforge:IO4Monoflop")).withDescription("Triggers a monoflop as configured")
.withCommandDescription(CommandDescriptionBuilder.create().withCommandOption(new CommandOption("TRIGGER", "Trigger")).build()).build();
            case "IO4EdgeCount":
                return ChannelTypeBuilder.state(new ChannelTypeUID("tinkerforge", "IO4EdgeCount"), "Edge Count", "Number:Dimensionless").withConfigDescriptionURI(URI.create("channel-type:tinkerforge:IO4EdgeCount")).withDescription("The current value of the edge counter for the selected channel")
.withStateDescription(StateDescriptionFragmentBuilder.create().withReadOnly(true).build().toStateDescription()).build();
            default:
                static_logger.debug("Unknown channel type ID {}", channelTypeUID.getId());
                break;
        }

        return null;
    }

    public static ThingType getThingType(ThingTypeUID thingTypeUID) {
        return ThingTypeBuilder.instance(thingTypeUID, "Tinkerforge IO-4 Bricklet").isListed(false).withSupportedBridgeTypeUIDs(Arrays.asList(TinkerforgeBindingConstants.THING_TYPE_BRICK_DAEMON.getId())).withConfigDescriptionURI(URI.create("thing-type:tinkerforge:" + thingTypeUID.getId())).withDescription("4-channel digital input/output").withChannelDefinitions(Arrays.asList(new ChannelDefinitionBuilder("IO4InputPin0", new ChannelTypeUID("tinkerforge", "IO4InputPin")).withLabel("Measured Level (Pin 0)").build(), new ChannelDefinitionBuilder("IO4InputPin1", new ChannelTypeUID("tinkerforge", "IO4InputPin")).withLabel("Measured Level (Pin 1)").build(), new ChannelDefinitionBuilder("IO4InputPin2", new ChannelTypeUID("tinkerforge", "IO4InputPin")).withLabel("Measured Level (Pin 2)").build(), new ChannelDefinitionBuilder("IO4InputPin3", new ChannelTypeUID("tinkerforge", "IO4InputPin")).withLabel("Measured Level (Pin 3)").build(), new ChannelDefinitionBuilder("IO4OutputPin0", new ChannelTypeUID("tinkerforge", "IO4OutputPin")).withLabel("Set Level (Pin 0)").build(), new ChannelDefinitionBuilder("IO4OutputPin1", new ChannelTypeUID("tinkerforge", "IO4OutputPin")).withLabel("Set Level (Pin 1)").build(), new ChannelDefinitionBuilder("IO4OutputPin2", new ChannelTypeUID("tinkerforge", "IO4OutputPin")).withLabel("Set Level (Pin 2)").build(), new ChannelDefinitionBuilder("IO4OutputPin3", new ChannelTypeUID("tinkerforge", "IO4OutputPin")).withLabel("Set Level (Pin 3)").build(), new ChannelDefinitionBuilder("IO4MonoflopPin0", new ChannelTypeUID("tinkerforge", "IO4Monoflop")).withLabel("Monoflop Pin 0").build(), new ChannelDefinitionBuilder("IO4MonoflopPin1", new ChannelTypeUID("tinkerforge", "IO4Monoflop")).withLabel("Monoflop Pin 1").build(), new ChannelDefinitionBuilder("IO4MonoflopPin2", new ChannelTypeUID("tinkerforge", "IO4Monoflop")).withLabel("Monoflop Pin 2").build(), new ChannelDefinitionBuilder("IO4MonoflopPin3", new ChannelTypeUID("tinkerforge", "IO4Monoflop")).withLabel("Monoflop Pin 3").build(), new ChannelDefinitionBuilder("IO4EdgeCountPin0", new ChannelTypeUID("tinkerforge", "IO4EdgeCount")).withLabel("Edge Count Pin 0").build(), new ChannelDefinitionBuilder("IO4EdgeCountPin1", new ChannelTypeUID("tinkerforge", "IO4EdgeCount")).withLabel("Edge Count Pin 1").build(), new ChannelDefinitionBuilder("IO4EdgeCountPin2", new ChannelTypeUID("tinkerforge", "IO4EdgeCount")).withLabel("Edge Count Pin 2").build(), new ChannelDefinitionBuilder("IO4EdgeCountPin3", new ChannelTypeUID("tinkerforge", "IO4EdgeCount")).withLabel("Edge Count Pin 3").build())).build();
    }

    public static ConfigDescription getConfigDescription(URI uri) {
        switch(uri.toASCIIString()) {
            case "thing-type:tinkerforge:io4":
                return new ConfigDescription(uri, Arrays.asList(ConfigDescriptionParameterBuilder.create("pinConfiguration0", Type.INTEGER).withDefault("3").withDescription("Configures the direction of pin 0. Inputs without pull-up will be floating if nothing is connected. Outputs can have an initial state of low or high.").withLabel("Pin Configuration 0").withLimitToOptions(true).withOptions(Arrays.asList(new ParameterOption("3", "Input with pull-up"), new ParameterOption("2", "Input without pull-up"), new ParameterOption("1", "Output (Initial high)"), new ParameterOption("0", "Output (Initial low)"))).build(), ConfigDescriptionParameterBuilder.create("pinConfiguration1", Type.INTEGER).withDefault("3").withDescription("Configures the direction of pin 1. Inputs without pull-up will be floating if nothing is connected. Outputs can have an initial state of low or high.").withLabel("Pin Configuration 1").withLimitToOptions(true).withOptions(Arrays.asList(new ParameterOption("3", "Input with pull-up"), new ParameterOption("2", "Input without pull-up"), new ParameterOption("1", "Output (Initial high)"), new ParameterOption("0", "Output (Initial low)"))).build(), ConfigDescriptionParameterBuilder.create("pinConfiguration2", Type.INTEGER).withDefault("3").withDescription("Configures the direction of pin 2. Inputs without pull-up will be floating if nothing is connected. Outputs can have an initial state of low or high.").withLabel("Pin Configuration 2").withLimitToOptions(true).withOptions(Arrays.asList(new ParameterOption("3", "Input with pull-up"), new ParameterOption("2", "Input without pull-up"), new ParameterOption("1", "Output (Initial high)"), new ParameterOption("0", "Output (Initial low)"))).build(), ConfigDescriptionParameterBuilder.create("pinConfiguration3", Type.INTEGER).withDefault("3").withDescription("Configures the direction of pin 3. Inputs without pull-up will be floating if nothing is connected. Outputs can have an initial state of low or high.").withLabel("Pin Configuration 3").withLimitToOptions(true).withOptions(Arrays.asList(new ParameterOption("3", "Input with pull-up"), new ParameterOption("2", "Input without pull-up"), new ParameterOption("1", "Output (Initial high)"), new ParameterOption("0", "Output (Initial low)"))).build()));
            case "channel-type:tinkerforge:IO4InputPin":
                return new ConfigDescription(uri, Arrays.asList(ConfigDescriptionParameterBuilder.create("updateInterval", Type.INTEGER).withDefault("1000").withDescription("Specifies the update interval in milliseconds. A value of 0 disables automatic updates.").withGroupName("update_intervals").withLabel("Update Interval").withUnit("ms").build()));
            case "channel-type:tinkerforge:IO4OutputPin":
                return new ConfigDescription(uri, Arrays.asList(ConfigDescriptionParameterBuilder.create("updateInterval", Type.INTEGER).withDefault("1000").withDescription("Specifies the update interval in milliseconds. A value of 0 disables automatic updates.").withGroupName("update_intervals").withLabel("Update Interval").withUnit("ms").build()));
            case "channel-type:tinkerforge:IO4Monoflop":
                return new ConfigDescription(uri, Arrays.asList(ConfigDescriptionParameterBuilder.create("monoflopDuration", Type.INTEGER).withDefault("1000").withDescription("The time (in ms) that the pin should hold the configured value.").withLabel("Monoflop duration").withUnit("ms").withMinimum(BigDecimal.valueOf(0)).withMaximum(BigDecimal.valueOf(2147483647)).build(), ConfigDescriptionParameterBuilder.create("monoflopValue", Type.BOOLEAN).withDefault("true").withDescription("The desired value of the specified channel. Activated means relay closed and Deactivated means relay open.").withLabel("Monoflop value").build()));
            case "channel-type:tinkerforge:IO4EdgeCount":
                return new ConfigDescription(uri, Arrays.asList(ConfigDescriptionParameterBuilder.create("updateInterval", Type.INTEGER).withDefault("1000").withDescription("Specifies the update interval in milliseconds. A value of 0 disables automatic updates.").withGroupName("update_intervals").withLabel("Update Interval").withUnit("ms").build(), ConfigDescriptionParameterBuilder.create("edgeType", Type.INTEGER).withDefault("0").withDescription("The edge type parameter configures if rising edges, falling edges or both are counted.").withLabel("Edge Type").withLimitToOptions(true).withOptions(Arrays.asList(new ParameterOption("0", "Rising"), new ParameterOption("1", "Falling"), new ParameterOption("2", "Both"))).build(), ConfigDescriptionParameterBuilder.create("debounce", Type.INTEGER).withDefault("100").withDescription("The debounce time in ms.").withLabel("Debounce Time").build(), ConfigDescriptionParameterBuilder.create("resetOnRead", Type.BOOLEAN).withDefault("false").withDescription("Enabling this will reset the edge counter after OpenHAB reads its value. Use this if you want relative edge counts per update.").withLabel("Reset Edge Count on Update").build()));
            default:
                static_logger.debug("Unknown config description URI {}", uri.toASCIIString());
                break;
        }
        return null;
    }

        @Override
    public void refreshValue(String value, org.eclipse.smarthome.config.core.Configuration config, org.eclipse.smarthome.config.core.Configuration channelConfig, BiConsumer<String, org.eclipse.smarthome.core.types.State> updateStateFn, BiConsumer<String, String> triggerChannelFn) throws TinkerforgeException {
        BrickletIO4Config cfg = (BrickletIO4Config) config.as(BrickletIO4Config.class);
        switch(value) {
            case "IO4InputPin0": {
                   BrickletIO4InputPinConfig channelCfg = channelConfig.as(BrickletIO4InputPinConfig.class);
                   updateStateFn.accept(value, transformIO4InputPin0Getter0(this.getValue(), cfg));
                   return;
               }
            case "IO4InputPin1": {
                   BrickletIO4InputPinConfig channelCfg = channelConfig.as(BrickletIO4InputPinConfig.class);
                   updateStateFn.accept(value, transformIO4InputPin1Getter0(this.getValue(), cfg));
                   return;
               }
            case "IO4InputPin2": {
                   BrickletIO4InputPinConfig channelCfg = channelConfig.as(BrickletIO4InputPinConfig.class);
                   updateStateFn.accept(value, transformIO4InputPin2Getter0(this.getValue(), cfg));
                   return;
               }
            case "IO4InputPin3": {
                   BrickletIO4InputPinConfig channelCfg = channelConfig.as(BrickletIO4InputPinConfig.class);
                   updateStateFn.accept(value, transformIO4InputPin3Getter0(this.getValue(), cfg));
                   return;
               }
            case "IO4OutputPin0": {
                   BrickletIO4OutputPinConfig channelCfg = channelConfig.as(BrickletIO4OutputPinConfig.class);
                   updateStateFn.accept(value, transformIO4OutputPin0Getter0(this.getValue(), cfg));
                   return;
               }
            case "IO4OutputPin1": {
                   BrickletIO4OutputPinConfig channelCfg = channelConfig.as(BrickletIO4OutputPinConfig.class);
                   updateStateFn.accept(value, transformIO4OutputPin1Getter0(this.getValue(), cfg));
                   return;
               }
            case "IO4OutputPin2": {
                   BrickletIO4OutputPinConfig channelCfg = channelConfig.as(BrickletIO4OutputPinConfig.class);
                   updateStateFn.accept(value, transformIO4OutputPin2Getter0(this.getValue(), cfg));
                   return;
               }
            case "IO4OutputPin3": {
                   BrickletIO4OutputPinConfig channelCfg = channelConfig.as(BrickletIO4OutputPinConfig.class);
                   updateStateFn.accept(value, transformIO4OutputPin3Getter0(this.getValue(), cfg));
                   return;
               }
            case "IO4MonoflopPin0": {
                   BrickletIO4MonoflopConfig channelCfg = channelConfig.as(BrickletIO4MonoflopConfig.class);
                   updateStateFn.accept(value, transformIO4MonoflopPin0Getter0(this.getMonoflop((short)0), cfg));
                   return;
               }
            case "IO4MonoflopPin1": {
                   BrickletIO4MonoflopConfig channelCfg = channelConfig.as(BrickletIO4MonoflopConfig.class);
                   updateStateFn.accept(value, transformIO4MonoflopPin1Getter0(this.getMonoflop((short)1), cfg));
                   return;
               }
            case "IO4MonoflopPin2": {
                   BrickletIO4MonoflopConfig channelCfg = channelConfig.as(BrickletIO4MonoflopConfig.class);
                   updateStateFn.accept(value, transformIO4MonoflopPin2Getter0(this.getMonoflop((short)2), cfg));
                   return;
               }
            case "IO4MonoflopPin3": {
                   BrickletIO4MonoflopConfig channelCfg = channelConfig.as(BrickletIO4MonoflopConfig.class);
                   updateStateFn.accept(value, transformIO4MonoflopPin3Getter0(this.getMonoflop((short)3), cfg));
                   return;
               }
            case "IO4EdgeCountPin0": {
                   BrickletIO4EdgeCountConfig channelCfg = channelConfig.as(BrickletIO4EdgeCountConfig.class);
                   updateStateFn.accept(value, transformIO4EdgeCountPin0Getter0(this.getEdgeCount((short)0, channelCfg.resetOnRead), cfg));
                   return;
               }
            case "IO4EdgeCountPin1": {
                   BrickletIO4EdgeCountConfig channelCfg = channelConfig.as(BrickletIO4EdgeCountConfig.class);
                   updateStateFn.accept(value, transformIO4EdgeCountPin1Getter0(this.getEdgeCount((short)1, channelCfg.resetOnRead), cfg));
                   return;
               }
            case "IO4EdgeCountPin2": {
                   BrickletIO4EdgeCountConfig channelCfg = channelConfig.as(BrickletIO4EdgeCountConfig.class);
                   updateStateFn.accept(value, transformIO4EdgeCountPin2Getter0(this.getEdgeCount((short)2, channelCfg.resetOnRead), cfg));
                   return;
               }
            case "IO4EdgeCountPin3": {
                   BrickletIO4EdgeCountConfig channelCfg = channelConfig.as(BrickletIO4EdgeCountConfig.class);
                   updateStateFn.accept(value, transformIO4EdgeCountPin3Getter0(this.getEdgeCount((short)3, channelCfg.resetOnRead), cfg));
                   return;
               }
            default:
                logger.warn("Refresh for unknown channel {}", value);
                break;
        }
    }
    

        @Override
    public List<SetterRefresh> handleCommand(org.eclipse.smarthome.config.core.Configuration config, org.eclipse.smarthome.config.core.Configuration channelConfig, String channel, Command command) throws TinkerforgeException {
        List<SetterRefresh> result = new ArrayList<SetterRefresh>();
        BrickletIO4Config cfg = (BrickletIO4Config) config.as(BrickletIO4Config.class);
        switch(channel) {
            case "IO4OutputPin0":
                if (command instanceof OnOffType) {
                    BrickletIO4OutputPinConfig channelCfg = channelConfig.as(BrickletIO4OutputPinConfig.class);
                    OnOffType cmd = (OnOffType) command;
                    this.setSelectedValues((short)(1 << 0), cmd == OnOffType.ON ? (short)0xFF : (short)0);
                    
                } else {
                    logger.warn("Command type {} not supported for channel {}. Please use a OnOffType.", command.getClass().getName(), channel);
                }
                break;
            case "IO4OutputPin1":
                if (command instanceof OnOffType) {
                    BrickletIO4OutputPinConfig channelCfg = channelConfig.as(BrickletIO4OutputPinConfig.class);
                    OnOffType cmd = (OnOffType) command;
                    this.setSelectedValues((short)(1 << 1), cmd == OnOffType.ON ? (short)0xFF : (short)0);
                    
                } else {
                    logger.warn("Command type {} not supported for channel {}. Please use a OnOffType.", command.getClass().getName(), channel);
                }
                break;
            case "IO4OutputPin2":
                if (command instanceof OnOffType) {
                    BrickletIO4OutputPinConfig channelCfg = channelConfig.as(BrickletIO4OutputPinConfig.class);
                    OnOffType cmd = (OnOffType) command;
                    this.setSelectedValues((short)(1 << 2), cmd == OnOffType.ON ? (short)0xFF : (short)0);
                    
                } else {
                    logger.warn("Command type {} not supported for channel {}. Please use a OnOffType.", command.getClass().getName(), channel);
                }
                break;
            case "IO4OutputPin3":
                if (command instanceof OnOffType) {
                    BrickletIO4OutputPinConfig channelCfg = channelConfig.as(BrickletIO4OutputPinConfig.class);
                    OnOffType cmd = (OnOffType) command;
                    this.setSelectedValues((short)(1 << 3), cmd == OnOffType.ON ? (short)0xFF : (short)0);
                    
                } else {
                    logger.warn("Command type {} not supported for channel {}. Please use a OnOffType.", command.getClass().getName(), channel);
                }
                break;
            case "IO4MonoflopPin0":
                if (command instanceof StringType) {
                    BrickletIO4MonoflopConfig channelCfg = channelConfig.as(BrickletIO4MonoflopConfig.class);
                    StringType cmd = (StringType) command;
                    this.setMonoflop((short)(1 << 0), channelCfg.monoflopValue.booleanValue() ? (short)0xFF : (short)0, channelCfg.monoflopDuration.longValue());
                    result.add(new SetterRefresh("IO4OutputPin0", 0));
                } else {
                    logger.warn("Command type {} not supported for channel {}. Please use a StringType.", command.getClass().getName(), channel);
                }
                break;
            case "IO4MonoflopPin1":
                if (command instanceof StringType) {
                    BrickletIO4MonoflopConfig channelCfg = channelConfig.as(BrickletIO4MonoflopConfig.class);
                    StringType cmd = (StringType) command;
                    this.setMonoflop((short)(1 << 1), channelCfg.monoflopValue.booleanValue() ? (short)0xFF : (short)0, channelCfg.monoflopDuration.longValue());
                    result.add(new SetterRefresh("IO4OutputPin1", 0));
                } else {
                    logger.warn("Command type {} not supported for channel {}. Please use a StringType.", command.getClass().getName(), channel);
                }
                break;
            case "IO4MonoflopPin2":
                if (command instanceof StringType) {
                    BrickletIO4MonoflopConfig channelCfg = channelConfig.as(BrickletIO4MonoflopConfig.class);
                    StringType cmd = (StringType) command;
                    this.setMonoflop((short)(1 << 2), channelCfg.monoflopValue.booleanValue() ? (short)0xFF : (short)0, channelCfg.monoflopDuration.longValue());
                    result.add(new SetterRefresh("IO4OutputPin2", 0));
                } else {
                    logger.warn("Command type {} not supported for channel {}. Please use a StringType.", command.getClass().getName(), channel);
                }
                break;
            case "IO4MonoflopPin3":
                if (command instanceof StringType) {
                    BrickletIO4MonoflopConfig channelCfg = channelConfig.as(BrickletIO4MonoflopConfig.class);
                    StringType cmd = (StringType) command;
                    this.setMonoflop((short)(1 << 3), channelCfg.monoflopValue.booleanValue() ? (short)0xFF : (short)0, channelCfg.monoflopDuration.longValue());
                    result.add(new SetterRefresh("IO4OutputPin3", 0));
                } else {
                    logger.warn("Command type {} not supported for channel {}. Please use a StringType.", command.getClass().getName(), channel);
                }
                break;
            default:
                logger.warn("Command for unknown channel {}", channel);
        }
        return result;
    }

        private org.eclipse.smarthome.core.types.State transformIO4InputPin0Callback0(short interruptMask, short valueMask, BrickletIO4Config cfg) {
        return (valueMask & (1 << 0)) > 0 ? OnOffType.ON : OnOffType.OFF;
    }
	    private org.eclipse.smarthome.core.types.State transformIO4InputPin1Callback0(short interruptMask, short valueMask, BrickletIO4Config cfg) {
        return (valueMask & (1 << 1)) > 0 ? OnOffType.ON : OnOffType.OFF;
    }
	    private org.eclipse.smarthome.core.types.State transformIO4InputPin2Callback0(short interruptMask, short valueMask, BrickletIO4Config cfg) {
        return (valueMask & (1 << 2)) > 0 ? OnOffType.ON : OnOffType.OFF;
    }
	    private org.eclipse.smarthome.core.types.State transformIO4InputPin3Callback0(short interruptMask, short valueMask, BrickletIO4Config cfg) {
        return (valueMask & (1 << 3)) > 0 ? OnOffType.ON : OnOffType.OFF;
    }
	    private org.eclipse.smarthome.core.types.State transformIO4OutputPin0Callback0(short selectionMask, short valueMask, BrickletIO4Config cfg) {
        return (valueMask & (1 << 0)) > 0 ? OnOffType.ON : OnOffType.OFF;
    }
	    private org.eclipse.smarthome.core.types.State transformIO4OutputPin1Callback0(short selectionMask, short valueMask, BrickletIO4Config cfg) {
        return (valueMask & (1 << 1)) > 0 ? OnOffType.ON : OnOffType.OFF;
    }
	    private org.eclipse.smarthome.core.types.State transformIO4OutputPin2Callback0(short selectionMask, short valueMask, BrickletIO4Config cfg) {
        return (valueMask & (1 << 2)) > 0 ? OnOffType.ON : OnOffType.OFF;
    }
	    private org.eclipse.smarthome.core.types.State transformIO4OutputPin3Callback0(short selectionMask, short valueMask, BrickletIO4Config cfg) {
        return (valueMask & (1 << 3)) > 0 ? OnOffType.ON : OnOffType.OFF;
    }
	    private org.eclipse.smarthome.core.types.State transformIO4InputPin0Getter0(short value, BrickletIO4Config cfg) {
        return (value & (1 << 0)) > 0 ? OnOffType.ON : OnOffType.OFF;
    }
	    private org.eclipse.smarthome.core.types.State transformIO4InputPin1Getter0(short value, BrickletIO4Config cfg) {
        return (value & (1 << 1)) > 0 ? OnOffType.ON : OnOffType.OFF;
    }
	    private org.eclipse.smarthome.core.types.State transformIO4InputPin2Getter0(short value, BrickletIO4Config cfg) {
        return (value & (1 << 2)) > 0 ? OnOffType.ON : OnOffType.OFF;
    }
	    private org.eclipse.smarthome.core.types.State transformIO4InputPin3Getter0(short value, BrickletIO4Config cfg) {
        return (value & (1 << 3)) > 0 ? OnOffType.ON : OnOffType.OFF;
    }
	    private org.eclipse.smarthome.core.types.State transformIO4OutputPin0Getter0(short value, BrickletIO4Config cfg) {
        return (value & (1 << 0)) > 0 ? OnOffType.ON : OnOffType.OFF;
    }
	    private org.eclipse.smarthome.core.types.State transformIO4OutputPin1Getter0(short value, BrickletIO4Config cfg) {
        return (value & (1 << 1)) > 0 ? OnOffType.ON : OnOffType.OFF;
    }
	    private org.eclipse.smarthome.core.types.State transformIO4OutputPin2Getter0(short value, BrickletIO4Config cfg) {
        return (value & (1 << 2)) > 0 ? OnOffType.ON : OnOffType.OFF;
    }
	    private org.eclipse.smarthome.core.types.State transformIO4OutputPin3Getter0(short value, BrickletIO4Config cfg) {
        return (value & (1 << 3)) > 0 ? OnOffType.ON : OnOffType.OFF;
    }
	    private org.eclipse.smarthome.core.types.State transformIO4MonoflopPin0Getter0(Monoflop value, BrickletIO4Config cfg) {
        return value.value > 0 ? OnOffType.ON : OnOffType.OFF;
    }
	    private org.eclipse.smarthome.core.types.State transformIO4MonoflopPin1Getter0(Monoflop value, BrickletIO4Config cfg) {
        return value.value > 0 ? OnOffType.ON : OnOffType.OFF;
    }
	    private org.eclipse.smarthome.core.types.State transformIO4MonoflopPin2Getter0(Monoflop value, BrickletIO4Config cfg) {
        return value.value > 0 ? OnOffType.ON : OnOffType.OFF;
    }
	    private org.eclipse.smarthome.core.types.State transformIO4MonoflopPin3Getter0(Monoflop value, BrickletIO4Config cfg) {
        return value.value > 0 ? OnOffType.ON : OnOffType.OFF;
    }
	    private org.eclipse.smarthome.core.types.State transformIO4EdgeCountPin0Getter0(long value, BrickletIO4Config cfg) {
        return new QuantityType<>(value, SmartHomeUnits.ONE);
    }
	    private org.eclipse.smarthome.core.types.State transformIO4EdgeCountPin1Getter0(long value, BrickletIO4Config cfg) {
        return new QuantityType<>(value, SmartHomeUnits.ONE);
    }
	    private org.eclipse.smarthome.core.types.State transformIO4EdgeCountPin2Getter0(long value, BrickletIO4Config cfg) {
        return new QuantityType<>(value, SmartHomeUnits.ONE);
    }
	    private org.eclipse.smarthome.core.types.State transformIO4EdgeCountPin3Getter0(long value, BrickletIO4Config cfg) {
        return new QuantityType<>(value, SmartHomeUnits.ONE);
    }
}
