/* ***********************************************************
 * This file was automatically generated on 2019-09-13.      *
 *                                                           *
 * OpenHAB Bindings Version 2.1.23                           *
 *                                                           *
 * If you have a bugfix for this file and want to commit it, *
 * please fix the bug in the generator. You can find a link  *
 * to the generators git repository on tinkerforge.com       *
 *************************************************************/

package com.tinkerforge;

import java.nio.ByteBuffer;
import java.nio.ByteOrder;
import java.util.concurrent.CopyOnWriteArrayList;
import java.util.Arrays;
import java.util.List;
import java.net.URI;
import java.math.BigDecimal;
import java.util.ArrayList;
import java.util.Collections;
import java.util.function.Function;
import java.util.function.BiConsumer;
import org.eclipse.smarthome.config.core.Configuration;
import org.eclipse.smarthome.config.core.ConfigDescription;
import org.eclipse.smarthome.config.core.ConfigDescriptionParameter.Type;
import org.eclipse.smarthome.config.core.ConfigDescriptionParameterBuilder;
import org.eclipse.smarthome.config.core.ConfigDescriptionParameterGroup;
import org.eclipse.smarthome.config.core.ParameterOption;
import org.eclipse.smarthome.core.types.State;
import org.eclipse.smarthome.core.types.StateOption;
import org.eclipse.smarthome.core.types.Command;
import org.eclipse.smarthome.core.types.CommandDescriptionBuilder;
import org.eclipse.smarthome.core.types.CommandOption;
import org.eclipse.smarthome.core.thing.ThingTypeUID;
import org.eclipse.smarthome.core.thing.type.ChannelDefinitionBuilder;
import org.eclipse.smarthome.core.thing.type.ChannelType;
import org.eclipse.smarthome.core.thing.type.ChannelTypeBuilder;
import org.eclipse.smarthome.core.thing.type.ChannelTypeUID;
import org.eclipse.smarthome.core.thing.type.ThingType;
import org.eclipse.smarthome.core.thing.type.ThingTypeBuilder;
import org.eclipse.smarthome.core.types.StateDescriptionFragmentBuilder;
import org.eclipse.smarthome.binding.tinkerforge.internal.TinkerforgeBindingConstants;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.eclipse.smarthome.core.library.types.QuantityType;
import org.eclipse.smarthome.core.library.unit.MetricPrefix;
import org.eclipse.smarthome.core.library.unit.SIUnits;
import org.eclipse.smarthome.core.library.unit.SmartHomeUnits;
import org.eclipse.smarthome.core.library.types.OnOffType;
import org.eclipse.smarthome.core.library.types.StringType;

/**
 * 4 galvanically isolated digital inputs
 */
public class BrickletIndustrialDigitalIn4 extends Device {
	public final static int DEVICE_IDENTIFIER = 223;
	public final static String DEVICE_DISPLAY_NAME = "Industrial Digital In 4 Bricklet";

    public final static DeviceInfo DEVICE_INFO = new DeviceInfo(DEVICE_DISPLAY_NAME, "industrialdigitalin4", DEVICE_IDENTIFIER, BrickletIndustrialDigitalIn4.class);

	public final static byte FUNCTION_GET_VALUE = (byte)1;
	public final static byte FUNCTION_SET_GROUP = (byte)2;
	public final static byte FUNCTION_GET_GROUP = (byte)3;
	public final static byte FUNCTION_GET_AVAILABLE_FOR_GROUP = (byte)4;
	public final static byte FUNCTION_SET_DEBOUNCE_PERIOD = (byte)5;
	public final static byte FUNCTION_GET_DEBOUNCE_PERIOD = (byte)6;
	public final static byte FUNCTION_SET_INTERRUPT = (byte)7;
	public final static byte FUNCTION_GET_INTERRUPT = (byte)8;
	public final static byte FUNCTION_GET_EDGE_COUNT = (byte)10;
	public final static byte FUNCTION_SET_EDGE_COUNT_CONFIG = (byte)11;
	public final static byte FUNCTION_GET_EDGE_COUNT_CONFIG = (byte)12;
	public final static byte FUNCTION_GET_IDENTITY = (byte)255;
	private final static int CALLBACK_INTERRUPT = 9;

	public final static short EDGE_TYPE_RISING = (short)0;
	public final static short EDGE_TYPE_FALLING = (short)1;
	public final static short EDGE_TYPE_BOTH = (short)2;

	private List<InterruptListener> listenerInterrupt = new CopyOnWriteArrayList<InterruptListener>();

	public class EdgeCountConfig {
		public short edgeType;
		public short debounce;

		public String toString() {
			return "[" + "edgeType = " + edgeType + ", " + "debounce = " + debounce + "]";
		}
	}

	/**
	 * This listener is triggered whenever a change of the voltage level is detected
	 * on pins where the interrupt was activated with {@link BrickletIndustrialDigitalIn4#setInterrupt(int)}.
	 * 
	 * The values are a bitmask that specifies which interrupts occurred
	 * and the current value bitmask.
	 * 
	 * For example:
	 * 
	 * * (1, 1) or (0b0001, 0b0001) means that an interrupt on pin 0 occurred and
	 *   currently pin 0 is high and pins 1-3 are low.
	 * * (9, 14) or (0b1001, 0b1110) means that interrupts on pins 0 and 3
	 *   occurred and currently pin 0 is low and pins 1-3 are high.
	 */
	public interface InterruptListener extends DeviceListener {
		public void interrupt(int interruptMask, int valueMask);
	}

	/**
	 * Creates an object with the unique device ID \c uid. and adds it to
	 * the IP Connection \c ipcon.
	 */
	public BrickletIndustrialDigitalIn4(String uid, IPConnection ipcon) {
		super(uid, ipcon);

		apiVersion[0] = 2;
		apiVersion[1] = 0;
		apiVersion[2] = 1;
		responseExpected[IPConnection.unsignedByte(FUNCTION_GET_VALUE)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_SET_GROUP)] = RESPONSE_EXPECTED_FLAG_FALSE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_GET_GROUP)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_GET_AVAILABLE_FOR_GROUP)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_SET_DEBOUNCE_PERIOD)] = RESPONSE_EXPECTED_FLAG_TRUE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_GET_DEBOUNCE_PERIOD)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_SET_INTERRUPT)] = RESPONSE_EXPECTED_FLAG_TRUE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_GET_INTERRUPT)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_GET_EDGE_COUNT)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_SET_EDGE_COUNT_CONFIG)] = RESPONSE_EXPECTED_FLAG_FALSE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_GET_EDGE_COUNT_CONFIG)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_GET_IDENTITY)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;

		callbacks[CALLBACK_INTERRUPT] = new IPConnection.DeviceCallbackListener() {
			public void callback(byte[] packet) {
				ByteBuffer bb = ByteBuffer.wrap(packet, 8, packet.length - 8);
				bb.order(ByteOrder.LITTLE_ENDIAN);

				int interruptMask = IPConnection.unsignedShort(bb.getShort());
				int valueMask = IPConnection.unsignedShort(bb.getShort());

				for (InterruptListener listener: listenerInterrupt) {
					listener.interrupt(interruptMask, valueMask);
				}
			}
		};
	}

	/**
	 * Returns the input value with a bitmask. The bitmask is 16bit long, *true*
	 * refers to high and *false* refers to low.
	 * 
	 * For example: The value 3 or 0b0011 means that pins 0-1 are high and the other
	 * pins are low.
	 * 
	 * If no groups are used (see {@link BrickletIndustrialDigitalIn4#setGroup(char[])}), the pins correspond to the
	 * markings on the IndustrialDigital In 4 Bricklet.
	 * 
	 * If groups are used, the pins correspond to the element in the group.
	 * Element 1 in the group will get pins 0-3, element 2 pins 4-7, element 3
	 * pins 8-11 and element 4 pins 12-15.
	 */
	public int getValue() throws TinkerforgeException {
		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_VALUE, this);


		byte[] response = sendRequest(bb.array());

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		int valueMask = IPConnection.unsignedShort(bb.getShort());

		return valueMask;
	}

	/**
	 * Sets a group of Digital In 4 Bricklets that should work together. You can
	 * find Bricklets that can be grouped together with {@link BrickletIndustrialDigitalIn4#getAvailableForGroup()}.
	 * 
	 * The group consists of 4 elements. Element 1 in the group will get pins 0-3,
	 * element 2 pins 4-7, element 3 pins 8-11 and element 4 pins 12-15.
	 * 
	 * Each element can either be one of the ports ('a' to 'd') or 'n' if it should
	 * not be used.
	 * 
	 * For example: If you have two Digital In 4 Bricklets connected to port A and
	 * port B respectively, you could call with ``['a', 'b', 'n', 'n']``.
	 * 
	 * Now the pins on the Digital In 4 on port A are assigned to 0-3 and the
	 * pins on the Digital In 4 on port B are assigned to 4-7. It is now possible
	 * to call {@link BrickletIndustrialDigitalIn4#getValue()} and read out two Bricklets at the same time.
	 * 
	 * Changing the group configuration resets all edge counter configurations
	 * and values.
	 */
	public void setGroup(char[] group) throws TinkerforgeException {
		ByteBuffer bb = ipcon.createRequestPacket((byte)12, FUNCTION_SET_GROUP, this);

		for (int i = 0; i < 4; i++) {
			bb.put((byte)group[i]);
		}

		sendRequest(bb.array());
	}

	/**
	 * Returns the group as set by {@link BrickletIndustrialDigitalIn4#setGroup(char[])}
	 */
	public char[] getGroup() throws TinkerforgeException {
		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_GROUP, this);


		byte[] response = sendRequest(bb.array());

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		char[] group = new char[4];
		for (int i = 0; i < 4; i++) {
			group[i] = (char)(bb.get());
		}

		return group;
	}

	/**
	 * Returns a bitmask of ports that are available for grouping. For example the
	 * value 5 or 0b0101 means: Port A and port C are connected to Bricklets that
	 * can be grouped together.
	 */
	public short getAvailableForGroup() throws TinkerforgeException {
		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_AVAILABLE_FOR_GROUP, this);


		byte[] response = sendRequest(bb.array());

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		short available = IPConnection.unsignedByte(bb.get());

		return available;
	}

	/**
	 * Sets the debounce period of the {@link BrickletIndustrialDigitalIn4.InterruptListener} listener in ms.
	 * 
	 * For example: If you set this value to 100, you will get the interrupt
	 * maximal every 100ms. This is necessary if something that bounces is
	 * connected to the Digital In 4 Bricklet, such as a button.
	 * 
	 * The default value is 100.
	 */
	public void setDebouncePeriod(long debounce) throws TinkerforgeException {
		ByteBuffer bb = ipcon.createRequestPacket((byte)12, FUNCTION_SET_DEBOUNCE_PERIOD, this);

		bb.putInt((int)debounce);

		sendRequest(bb.array());
	}

	/**
	 * Returns the debounce period as set by {@link BrickletIndustrialDigitalIn4#setDebouncePeriod(long)}.
	 */
	public long getDebouncePeriod() throws TinkerforgeException {
		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_DEBOUNCE_PERIOD, this);


		byte[] response = sendRequest(bb.array());

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		long debounce = IPConnection.unsignedInt(bb.getInt());

		return debounce;
	}

	/**
	 * Sets the pins on which an interrupt is activated with a bitmask.
	 * Interrupts are triggered on changes of the voltage level of the pin,
	 * i.e. changes from high to low and low to high.
	 * 
	 * For example: An interrupt bitmask of 9 or 0b1001 will enable the interrupt for
	 * pins 0 and 3.
	 * 
	 * The interrupts use the grouping as set by {@link BrickletIndustrialDigitalIn4#setGroup(char[])}.
	 * 
	 * The interrupt is delivered with the {@link BrickletIndustrialDigitalIn4.InterruptListener} listener.
	 */
	public void setInterrupt(int interruptMask) throws TinkerforgeException {
		ByteBuffer bb = ipcon.createRequestPacket((byte)10, FUNCTION_SET_INTERRUPT, this);

		bb.putShort((short)interruptMask);

		sendRequest(bb.array());
	}

	/**
	 * Returns the interrupt bitmask as set by {@link BrickletIndustrialDigitalIn4#setInterrupt(int)}.
	 */
	public int getInterrupt() throws TinkerforgeException {
		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_INTERRUPT, this);


		byte[] response = sendRequest(bb.array());

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		int interruptMask = IPConnection.unsignedShort(bb.getShort());

		return interruptMask;
	}

	/**
	 * Returns the current value of the edge counter for the selected pin. You can
	 * configure the edges that are counted with {@link BrickletIndustrialDigitalIn4#setEdgeCountConfig(int, short, short)}.
	 * 
	 * If you set the reset counter to *true*, the count is set back to 0
	 * directly after it is read.
	 * 
	 * .. versionadded:: 2.0.1$nbsp;(Plugin)
	 */
	public long getEdgeCount(short pin, boolean resetCounter) throws TinkerforgeException {
		ByteBuffer bb = ipcon.createRequestPacket((byte)10, FUNCTION_GET_EDGE_COUNT, this);

		bb.put((byte)pin);
		bb.put((byte)(resetCounter ? 1 : 0));

		byte[] response = sendRequest(bb.array());

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		long count = IPConnection.unsignedInt(bb.getInt());

		return count;
	}

	/**
	 * Configures the edge counter for the selected pins. A bitmask of 9 or 0b1001 will
	 * enable the edge counter for pins 0 and 3.
	 * 
	 * The edge type parameter configures if rising edges, falling edges or
	 * both are counted if the pin is configured for input. Possible edge types are:
	 * 
	 * * 0 = rising (default)
	 * * 1 = falling
	 * * 2 = both
	 * 
	 * The debounce time is given in ms.
	 * 
	 * Configuring an edge counter resets its value to 0.
	 * 
	 * If you don't know what any of this means, just leave it at default. The
	 * default configuration is very likely OK for you.
	 * 
	 * Default values: 0 (edge type) and 100ms (debounce time)
	 * 
	 * .. versionadded:: 2.0.1$nbsp;(Plugin)
	 */
	public void setEdgeCountConfig(int selectionMask, short edgeType, short debounce) throws TinkerforgeException {
		ByteBuffer bb = ipcon.createRequestPacket((byte)12, FUNCTION_SET_EDGE_COUNT_CONFIG, this);

		bb.putShort((short)selectionMask);
		bb.put((byte)edgeType);
		bb.put((byte)debounce);

		sendRequest(bb.array());
	}

	/**
	 * Returns the edge type and debounce time for the selected pin as set by
	 * {@link BrickletIndustrialDigitalIn4#setEdgeCountConfig(int, short, short)}.
	 * 
	 * .. versionadded:: 2.0.1$nbsp;(Plugin)
	 */
	public EdgeCountConfig getEdgeCountConfig(short pin) throws TinkerforgeException {
		ByteBuffer bb = ipcon.createRequestPacket((byte)9, FUNCTION_GET_EDGE_COUNT_CONFIG, this);

		bb.put((byte)pin);

		byte[] response = sendRequest(bb.array());

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		EdgeCountConfig obj = new EdgeCountConfig();
		obj.edgeType = IPConnection.unsignedByte(bb.get());
		obj.debounce = IPConnection.unsignedByte(bb.get());

		return obj;
	}

	/**
	 * Returns the UID, the UID where the Bricklet is connected to,
	 * the position, the hardware and firmware version as well as the
	 * device identifier.
	 * 
	 * The position can be 'a', 'b', 'c' or 'd'.
	 * 
	 * The device identifier numbers can be found :ref:`here &lt;device_identifier&gt;`.
	 * |device_identifier_constant|
	 */
	public Identity getIdentity() throws TinkerforgeException {
		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_IDENTITY, this);


		byte[] response = sendRequest(bb.array());

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		Identity obj = new Identity();
		obj.uid = IPConnection.string(bb, 8);
		obj.connectedUid = IPConnection.string(bb, 8);
		obj.position = (char)(bb.get());
		for (int i = 0; i < 3; i++) {
			obj.hardwareVersion[i] = IPConnection.unsignedByte(bb.get());
		}
		for (int i = 0; i < 3; i++) {
			obj.firmwareVersion[i] = IPConnection.unsignedByte(bb.get());
		}
		obj.deviceIdentifier = IPConnection.unsignedShort(bb.getShort());

		return obj;
	}

	/**
	 * Adds a Interrupt listener.
	 */
	public void addInterruptListener(InterruptListener listener) {
		listenerInterrupt.add(listener);
	}

	/**
	 * Removes a Interrupt listener.
	 */
	public void removeInterruptListener(InterruptListener listener) {
		listenerInterrupt.remove(listener);
	}

    private final Logger logger = LoggerFactory.getLogger(BrickletIndustrialDigitalIn4.class);
    private final static Logger static_logger = LoggerFactory.getLogger(BrickletIndustrialDigitalIn4.class);

    @Override
    public void initialize(org.eclipse.smarthome.config.core.Configuration config, Function<String, org.eclipse.smarthome.config.core.Configuration> getChannelConfigFn, BiConsumer<String, org.eclipse.smarthome.core.types.State> updateStateFn, BiConsumer<String, String> triggerChannelFn) throws TinkerforgeException {
        BrickletIndustrialDigitalIn4Config cfg = (BrickletIndustrialDigitalIn4Config) config.as(BrickletIndustrialDigitalIn4Config.class);
        this.addInterruptListener((interruptMask, valueMask) -> {if((interruptMask & (1 << 0)) > 0) {updateStateFn.accept("IndustrialDigitalIn4InputPin0", transformIndustrialDigitalIn4InputPin0Callback0(interruptMask, valueMask, cfg));}});
		this.addInterruptListener((interruptMask, valueMask) -> {if((interruptMask & (1 << 1)) > 0) {updateStateFn.accept("IndustrialDigitalIn4InputPin1", transformIndustrialDigitalIn4InputPin1Callback0(interruptMask, valueMask, cfg));}});
		this.addInterruptListener((interruptMask, valueMask) -> {if((interruptMask & (1 << 2)) > 0) {updateStateFn.accept("IndustrialDigitalIn4InputPin2", transformIndustrialDigitalIn4InputPin2Callback0(interruptMask, valueMask, cfg));}});
		this.addInterruptListener((interruptMask, valueMask) -> {if((interruptMask & (1 << 3)) > 0) {updateStateFn.accept("IndustrialDigitalIn4InputPin3", transformIndustrialDigitalIn4InputPin3Callback0(interruptMask, valueMask, cfg));}});
        
		{
		BrickletIndustrialDigitalIn4InputPinConfig channelCfg = getChannelConfigFn.apply("IndustrialDigitalIn4InputPin0").as(BrickletIndustrialDigitalIn4InputPinConfig.class);
		this.setInterrupt((short)(this.getInterrupt() | (1 << 0)));
		}
		{
		BrickletIndustrialDigitalIn4InputPinConfig channelCfg = getChannelConfigFn.apply("IndustrialDigitalIn4InputPin1").as(BrickletIndustrialDigitalIn4InputPinConfig.class);
		this.setInterrupt((short)(this.getInterrupt() | (1 << 1)));
		}
		{
		BrickletIndustrialDigitalIn4InputPinConfig channelCfg = getChannelConfigFn.apply("IndustrialDigitalIn4InputPin2").as(BrickletIndustrialDigitalIn4InputPinConfig.class);
		this.setInterrupt((short)(this.getInterrupt() | (1 << 2)));
		}
		{
		BrickletIndustrialDigitalIn4InputPinConfig channelCfg = getChannelConfigFn.apply("IndustrialDigitalIn4InputPin3").as(BrickletIndustrialDigitalIn4InputPinConfig.class);
		this.setInterrupt((short)(this.getInterrupt() | (1 << 3)));
		}
		{
		BrickletIndustrialDigitalIn4EdgeCountConfig channelCfg = getChannelConfigFn.apply("IndustrialDigitalIn4EdgeCountPin0").as(BrickletIndustrialDigitalIn4EdgeCountConfig.class);
		this.setEdgeCountConfig((short)(1 << 0), channelCfg.edgeType.shortValue(), channelCfg.debounce.shortValue());
		}
		{
		BrickletIndustrialDigitalIn4EdgeCountConfig channelCfg = getChannelConfigFn.apply("IndustrialDigitalIn4EdgeCountPin1").as(BrickletIndustrialDigitalIn4EdgeCountConfig.class);
		this.setEdgeCountConfig((short)(1 << 1), channelCfg.edgeType.shortValue(), channelCfg.debounce.shortValue());
		}
		{
		BrickletIndustrialDigitalIn4EdgeCountConfig channelCfg = getChannelConfigFn.apply("IndustrialDigitalIn4EdgeCountPin2").as(BrickletIndustrialDigitalIn4EdgeCountConfig.class);
		this.setEdgeCountConfig((short)(1 << 2), channelCfg.edgeType.shortValue(), channelCfg.debounce.shortValue());
		}
		{
		BrickletIndustrialDigitalIn4EdgeCountConfig channelCfg = getChannelConfigFn.apply("IndustrialDigitalIn4EdgeCountPin3").as(BrickletIndustrialDigitalIn4EdgeCountConfig.class);
		this.setEdgeCountConfig((short)(1 << 3), channelCfg.edgeType.shortValue(), channelCfg.debounce.shortValue());
		}
    }

    @Override
    public void dispose(org.eclipse.smarthome.config.core.Configuration config) throws TinkerforgeException {
        BrickletIndustrialDigitalIn4Config cfg = (BrickletIndustrialDigitalIn4Config) config.as(BrickletIndustrialDigitalIn4Config.class);
        this.listenerInterrupt.clear();
		this.listenerInterrupt.clear();
		this.listenerInterrupt.clear();
		this.listenerInterrupt.clear();
        this.setInterrupt((short)(this.getInterrupt() & ~(1 << 0)));
		this.setInterrupt((short)(this.getInterrupt() & ~(1 << 1)));
		this.setInterrupt((short)(this.getInterrupt() & ~(1 << 2)));
		this.setInterrupt((short)(this.getInterrupt() & ~(1 << 3)));
		
    }

    @Override
    public List<String> getEnabledChannels(org.eclipse.smarthome.config.core.Configuration config) throws TinkerforgeException{
        BrickletIndustrialDigitalIn4Config cfg = (BrickletIndustrialDigitalIn4Config) config.as(BrickletIndustrialDigitalIn4Config.class);
        List<String> result = new ArrayList<String>();
        result.add("IndustrialDigitalIn4InputPin0");
		result.add("IndustrialDigitalIn4InputPin1");
		result.add("IndustrialDigitalIn4InputPin2");
		result.add("IndustrialDigitalIn4InputPin3");
		result.add("IndustrialDigitalIn4EdgeCountPin0");
		result.add("IndustrialDigitalIn4EdgeCountPin1");
		result.add("IndustrialDigitalIn4EdgeCountPin2");
		result.add("IndustrialDigitalIn4EdgeCountPin3");
        return result;
    }

    public static ChannelType getChannelType(ChannelTypeUID channelTypeUID) {
        switch(channelTypeUID.getId()) {
            case "IndustrialDigitalIn4InputPin":
                return ChannelTypeBuilder.state(new ChannelTypeUID("tinkerforge", "IndustrialDigitalIn4InputPin"), "Measured Level", "Switch").withConfigDescriptionURI(URI.create("channel-type:tinkerforge:IndustrialDigitalIn4InputPin")).withDescription("The logic level that is currently measured on the pin.")
.withStateDescription(StateDescriptionFragmentBuilder.create().withReadOnly(true).build().toStateDescription()).build();
            case "IndustrialDigitalIn4EdgeCount":
                return ChannelTypeBuilder.state(new ChannelTypeUID("tinkerforge", "IndustrialDigitalIn4EdgeCount"), "Edge Count", "Number:Dimensionless").withConfigDescriptionURI(URI.create("channel-type:tinkerforge:IndustrialDigitalIn4EdgeCount")).withDescription("The current value of the edge counter for the selected channel")
.withStateDescription(StateDescriptionFragmentBuilder.create().withReadOnly(true).build().toStateDescription()).build();
            default:
                static_logger.debug("Unknown channel type ID {}", channelTypeUID.getId());
                break;
        }

        return null;
    }

    public static ThingType getThingType(ThingTypeUID thingTypeUID) {
        return ThingTypeBuilder.instance(thingTypeUID, "Tinkerforge Industrial Digital In 4 Bricklet").isListed(false).withSupportedBridgeTypeUIDs(Arrays.asList(TinkerforgeBindingConstants.THING_TYPE_BRICK_DAEMON.getId())).withConfigDescriptionURI(URI.create("thing-type:tinkerforge:" + thingTypeUID.getId())).withDescription("4 galvanically isolated digital inputs").withChannelDefinitions(Arrays.asList(new ChannelDefinitionBuilder("IndustrialDigitalIn4InputPin0", new ChannelTypeUID("tinkerforge", "IndustrialDigitalIn4InputPin")).withLabel("Measured Level (Pin 0)").build(), new ChannelDefinitionBuilder("IndustrialDigitalIn4InputPin1", new ChannelTypeUID("tinkerforge", "IndustrialDigitalIn4InputPin")).withLabel("Measured Level (Pin 1)").build(), new ChannelDefinitionBuilder("IndustrialDigitalIn4InputPin2", new ChannelTypeUID("tinkerforge", "IndustrialDigitalIn4InputPin")).withLabel("Measured Level (Pin 2)").build(), new ChannelDefinitionBuilder("IndustrialDigitalIn4InputPin3", new ChannelTypeUID("tinkerforge", "IndustrialDigitalIn4InputPin")).withLabel("Measured Level (Pin 3)").build(), new ChannelDefinitionBuilder("IndustrialDigitalIn4EdgeCountPin0", new ChannelTypeUID("tinkerforge", "IndustrialDigitalIn4EdgeCount")).withLabel("Edge Count Pin 0").build(), new ChannelDefinitionBuilder("IndustrialDigitalIn4EdgeCountPin1", new ChannelTypeUID("tinkerforge", "IndustrialDigitalIn4EdgeCount")).withLabel("Edge Count Pin 1").build(), new ChannelDefinitionBuilder("IndustrialDigitalIn4EdgeCountPin2", new ChannelTypeUID("tinkerforge", "IndustrialDigitalIn4EdgeCount")).withLabel("Edge Count Pin 2").build(), new ChannelDefinitionBuilder("IndustrialDigitalIn4EdgeCountPin3", new ChannelTypeUID("tinkerforge", "IndustrialDigitalIn4EdgeCount")).withLabel("Edge Count Pin 3").build())).build();
    }

    public static ConfigDescription getConfigDescription(URI uri) {
        switch(uri.toASCIIString()) {
            case "thing-type:tinkerforge:industrialdigitalin4":
                return new ConfigDescription(uri, Arrays.asList());
            case "channel-type:tinkerforge:IndustrialDigitalIn4InputPin":
                return new ConfigDescription(uri, Arrays.asList(ConfigDescriptionParameterBuilder.create("updateInterval", Type.INTEGER).withDefault("1000").withDescription("Specifies the update interval in milliseconds. A value of 0 disables automatic updates.").withGroupName("update_intervals").withLabel("Update Interval").withUnit("ms").build()));
            case "channel-type:tinkerforge:IndustrialDigitalIn4EdgeCount":
                return new ConfigDescription(uri, Arrays.asList(ConfigDescriptionParameterBuilder.create("updateInterval", Type.INTEGER).withDefault("1000").withDescription("Specifies the update interval in milliseconds. A value of 0 disables automatic updates.").withGroupName("update_intervals").withLabel("Update Interval").withUnit("ms").build(), ConfigDescriptionParameterBuilder.create("edgeType", Type.INTEGER).withDefault("0").withDescription("The edge type parameter configures if rising edges, falling edges or both are counted.").withLabel("Edge Type").withLimitToOptions(true).withOptions(Arrays.asList(new ParameterOption("0", "Rising"), new ParameterOption("1", "Falling"), new ParameterOption("2", "Both"))).build(), ConfigDescriptionParameterBuilder.create("debounce", Type.INTEGER).withDefault("100").withDescription("The debounce time in ms.").withLabel("Debounce Time").build(), ConfigDescriptionParameterBuilder.create("resetOnRead", Type.BOOLEAN).withDefault("false").withDescription("Enabling this will reset the edge counter after OpenHAB reads its value. Use this if you want relative edge counts per update.").withLabel("Reset Edge Count on Update").build()));
            default:
                static_logger.debug("Unknown config description URI {}", uri.toASCIIString());
                break;
        }
        return null;
    }

        @Override
    public void refreshValue(String value, org.eclipse.smarthome.config.core.Configuration config, org.eclipse.smarthome.config.core.Configuration channelConfig, BiConsumer<String, org.eclipse.smarthome.core.types.State> updateStateFn, BiConsumer<String, String> triggerChannelFn) throws TinkerforgeException {
        BrickletIndustrialDigitalIn4Config cfg = (BrickletIndustrialDigitalIn4Config) config.as(BrickletIndustrialDigitalIn4Config.class);
        switch(value) {
            case "IndustrialDigitalIn4InputPin0": {
                   BrickletIndustrialDigitalIn4InputPinConfig channelCfg = channelConfig.as(BrickletIndustrialDigitalIn4InputPinConfig.class);
                   updateStateFn.accept(value, transformIndustrialDigitalIn4InputPin0Getter0(this.getValue(), cfg));
                   return;
               }
            case "IndustrialDigitalIn4InputPin1": {
                   BrickletIndustrialDigitalIn4InputPinConfig channelCfg = channelConfig.as(BrickletIndustrialDigitalIn4InputPinConfig.class);
                   updateStateFn.accept(value, transformIndustrialDigitalIn4InputPin1Getter0(this.getValue(), cfg));
                   return;
               }
            case "IndustrialDigitalIn4InputPin2": {
                   BrickletIndustrialDigitalIn4InputPinConfig channelCfg = channelConfig.as(BrickletIndustrialDigitalIn4InputPinConfig.class);
                   updateStateFn.accept(value, transformIndustrialDigitalIn4InputPin2Getter0(this.getValue(), cfg));
                   return;
               }
            case "IndustrialDigitalIn4InputPin3": {
                   BrickletIndustrialDigitalIn4InputPinConfig channelCfg = channelConfig.as(BrickletIndustrialDigitalIn4InputPinConfig.class);
                   updateStateFn.accept(value, transformIndustrialDigitalIn4InputPin3Getter0(this.getValue(), cfg));
                   return;
               }
            case "IndustrialDigitalIn4EdgeCountPin0": {
                   BrickletIndustrialDigitalIn4EdgeCountConfig channelCfg = channelConfig.as(BrickletIndustrialDigitalIn4EdgeCountConfig.class);
                   updateStateFn.accept(value, transformIndustrialDigitalIn4EdgeCountPin0Getter0(this.getEdgeCount((short)0, channelCfg.resetOnRead), cfg));
                   return;
               }
            case "IndustrialDigitalIn4EdgeCountPin1": {
                   BrickletIndustrialDigitalIn4EdgeCountConfig channelCfg = channelConfig.as(BrickletIndustrialDigitalIn4EdgeCountConfig.class);
                   updateStateFn.accept(value, transformIndustrialDigitalIn4EdgeCountPin1Getter0(this.getEdgeCount((short)1, channelCfg.resetOnRead), cfg));
                   return;
               }
            case "IndustrialDigitalIn4EdgeCountPin2": {
                   BrickletIndustrialDigitalIn4EdgeCountConfig channelCfg = channelConfig.as(BrickletIndustrialDigitalIn4EdgeCountConfig.class);
                   updateStateFn.accept(value, transformIndustrialDigitalIn4EdgeCountPin2Getter0(this.getEdgeCount((short)2, channelCfg.resetOnRead), cfg));
                   return;
               }
            case "IndustrialDigitalIn4EdgeCountPin3": {
                   BrickletIndustrialDigitalIn4EdgeCountConfig channelCfg = channelConfig.as(BrickletIndustrialDigitalIn4EdgeCountConfig.class);
                   updateStateFn.accept(value, transformIndustrialDigitalIn4EdgeCountPin3Getter0(this.getEdgeCount((short)3, channelCfg.resetOnRead), cfg));
                   return;
               }
            default:
                logger.warn("Refresh for unknown channel {}", value);
                break;
        }
    }
    

        @Override
    public List<SetterRefresh> handleCommand(org.eclipse.smarthome.config.core.Configuration config, org.eclipse.smarthome.config.core.Configuration channelConfig, String channel, Command command) throws TinkerforgeException {
        List<SetterRefresh> result = Collections.emptyList();
        BrickletIndustrialDigitalIn4Config cfg = (BrickletIndustrialDigitalIn4Config) config.as(BrickletIndustrialDigitalIn4Config.class);
        switch(channel) {
            
            default:
                logger.warn("Command for unknown channel {}", channel);
        }
        return result;
    }

        private org.eclipse.smarthome.core.types.State transformIndustrialDigitalIn4InputPin0Callback0(int interruptMask, int valueMask, BrickletIndustrialDigitalIn4Config cfg) {
        return (valueMask & (1 << 0)) > 0 ? OnOffType.ON : OnOffType.OFF;
    }
	    private org.eclipse.smarthome.core.types.State transformIndustrialDigitalIn4InputPin1Callback0(int interruptMask, int valueMask, BrickletIndustrialDigitalIn4Config cfg) {
        return (valueMask & (1 << 1)) > 0 ? OnOffType.ON : OnOffType.OFF;
    }
	    private org.eclipse.smarthome.core.types.State transformIndustrialDigitalIn4InputPin2Callback0(int interruptMask, int valueMask, BrickletIndustrialDigitalIn4Config cfg) {
        return (valueMask & (1 << 2)) > 0 ? OnOffType.ON : OnOffType.OFF;
    }
	    private org.eclipse.smarthome.core.types.State transformIndustrialDigitalIn4InputPin3Callback0(int interruptMask, int valueMask, BrickletIndustrialDigitalIn4Config cfg) {
        return (valueMask & (1 << 3)) > 0 ? OnOffType.ON : OnOffType.OFF;
    }
	    private org.eclipse.smarthome.core.types.State transformIndustrialDigitalIn4InputPin0Getter0(int value, BrickletIndustrialDigitalIn4Config cfg) {
        return (value & (1 << 0)) > 0 ? OnOffType.ON : OnOffType.OFF;
    }
	    private org.eclipse.smarthome.core.types.State transformIndustrialDigitalIn4InputPin1Getter0(int value, BrickletIndustrialDigitalIn4Config cfg) {
        return (value & (1 << 1)) > 0 ? OnOffType.ON : OnOffType.OFF;
    }
	    private org.eclipse.smarthome.core.types.State transformIndustrialDigitalIn4InputPin2Getter0(int value, BrickletIndustrialDigitalIn4Config cfg) {
        return (value & (1 << 2)) > 0 ? OnOffType.ON : OnOffType.OFF;
    }
	    private org.eclipse.smarthome.core.types.State transformIndustrialDigitalIn4InputPin3Getter0(int value, BrickletIndustrialDigitalIn4Config cfg) {
        return (value & (1 << 3)) > 0 ? OnOffType.ON : OnOffType.OFF;
    }
	    private org.eclipse.smarthome.core.types.State transformIndustrialDigitalIn4EdgeCountPin0Getter0(long value, BrickletIndustrialDigitalIn4Config cfg) {
        return new QuantityType<>(value, SmartHomeUnits.ONE);
    }
	    private org.eclipse.smarthome.core.types.State transformIndustrialDigitalIn4EdgeCountPin1Getter0(long value, BrickletIndustrialDigitalIn4Config cfg) {
        return new QuantityType<>(value, SmartHomeUnits.ONE);
    }
	    private org.eclipse.smarthome.core.types.State transformIndustrialDigitalIn4EdgeCountPin2Getter0(long value, BrickletIndustrialDigitalIn4Config cfg) {
        return new QuantityType<>(value, SmartHomeUnits.ONE);
    }
	    private org.eclipse.smarthome.core.types.State transformIndustrialDigitalIn4EdgeCountPin3Getter0(long value, BrickletIndustrialDigitalIn4Config cfg) {
        return new QuantityType<>(value, SmartHomeUnits.ONE);
    }
}
