/* ***********************************************************
 * This file was automatically generated on 2019-09-13.      *
 *                                                           *
 * OpenHAB Bindings Version 2.1.23                           *
 *                                                           *
 * If you have a bugfix for this file and want to commit it, *
 * please fix the bug in the generator. You can find a link  *
 * to the generators git repository on tinkerforge.com       *
 *************************************************************/

package com.tinkerforge;

import java.nio.ByteBuffer;
import java.nio.ByteOrder;
import java.util.concurrent.CopyOnWriteArrayList;
import java.util.Arrays;
import java.util.List;
import java.net.URI;
import java.math.BigDecimal;
import java.util.ArrayList;
import java.util.Collections;
import java.util.function.Function;
import java.util.function.BiConsumer;
import org.eclipse.smarthome.config.core.Configuration;
import org.eclipse.smarthome.config.core.ConfigDescription;
import org.eclipse.smarthome.config.core.ConfigDescriptionParameter.Type;
import org.eclipse.smarthome.config.core.ConfigDescriptionParameterBuilder;
import org.eclipse.smarthome.config.core.ConfigDescriptionParameterGroup;
import org.eclipse.smarthome.config.core.ParameterOption;
import org.eclipse.smarthome.core.types.State;
import org.eclipse.smarthome.core.types.StateOption;
import org.eclipse.smarthome.core.types.Command;
import org.eclipse.smarthome.core.types.CommandDescriptionBuilder;
import org.eclipse.smarthome.core.types.CommandOption;
import org.eclipse.smarthome.core.thing.ThingTypeUID;
import org.eclipse.smarthome.core.thing.type.ChannelDefinitionBuilder;
import org.eclipse.smarthome.core.thing.type.ChannelType;
import org.eclipse.smarthome.core.thing.type.ChannelTypeBuilder;
import org.eclipse.smarthome.core.thing.type.ChannelTypeUID;
import org.eclipse.smarthome.core.thing.type.ThingType;
import org.eclipse.smarthome.core.thing.type.ThingTypeBuilder;
import org.eclipse.smarthome.core.types.StateDescriptionFragmentBuilder;
import org.eclipse.smarthome.binding.tinkerforge.internal.TinkerforgeBindingConstants;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.eclipse.smarthome.core.library.types.QuantityType;
import org.eclipse.smarthome.core.library.unit.MetricPrefix;
import org.eclipse.smarthome.core.library.unit.SIUnits;
import org.eclipse.smarthome.core.library.unit.SmartHomeUnits;
import org.eclipse.smarthome.core.thing.CommonTriggerEvents;
import org.eclipse.smarthome.core.library.types.StringType;
import org.eclipse.smarthome.core.library.types.DecimalType;
import org.eclipse.smarthome.core.library.types.OnOffType;
import com.tinkerforge.Helper;

/**
 * 16x2 character alphanumeric display with blue backlight
 */
public class BrickletLCD16x2 extends Device {
	public final static int DEVICE_IDENTIFIER = 211;
	public final static String DEVICE_DISPLAY_NAME = "LCD 16x2 Bricklet";

    public final static DeviceInfo DEVICE_INFO = new DeviceInfo(DEVICE_DISPLAY_NAME, "lcd16x2", DEVICE_IDENTIFIER, BrickletLCD16x2.class);

	public final static byte FUNCTION_WRITE_LINE = (byte)1;
	public final static byte FUNCTION_CLEAR_DISPLAY = (byte)2;
	public final static byte FUNCTION_BACKLIGHT_ON = (byte)3;
	public final static byte FUNCTION_BACKLIGHT_OFF = (byte)4;
	public final static byte FUNCTION_IS_BACKLIGHT_ON = (byte)5;
	public final static byte FUNCTION_SET_CONFIG = (byte)6;
	public final static byte FUNCTION_GET_CONFIG = (byte)7;
	public final static byte FUNCTION_IS_BUTTON_PRESSED = (byte)8;
	public final static byte FUNCTION_SET_CUSTOM_CHARACTER = (byte)11;
	public final static byte FUNCTION_GET_CUSTOM_CHARACTER = (byte)12;
	public final static byte FUNCTION_GET_IDENTITY = (byte)255;
	private final static int CALLBACK_BUTTON_PRESSED = 9;
	private final static int CALLBACK_BUTTON_RELEASED = 10;


	private List<ButtonPressedListener> listenerButtonPressed = new CopyOnWriteArrayList<ButtonPressedListener>();
	private List<ButtonReleasedListener> listenerButtonReleased = new CopyOnWriteArrayList<ButtonReleasedListener>();

	public class Config {
		public boolean cursor;
		public boolean blinking;

		public String toString() {
			return "[" + "cursor = " + cursor + ", " + "blinking = " + blinking + "]";
		}
	}

	/**
	 * This listener is triggered when a button is pressed. The parameter is
	 * the number of the button (0 to 2).
	 */
	public interface ButtonPressedListener extends DeviceListener {
		public void buttonPressed(short button);
	}

	/**
	 * This listener is triggered when a button is released. The parameter is
	 * the number of the button (0 to 2).
	 */
	public interface ButtonReleasedListener extends DeviceListener {
		public void buttonReleased(short button);
	}

	/**
	 * Creates an object with the unique device ID \c uid. and adds it to
	 * the IP Connection \c ipcon.
	 */
	public BrickletLCD16x2(String uid, IPConnection ipcon) {
		super(uid, ipcon);

		apiVersion[0] = 2;
		apiVersion[1] = 0;
		apiVersion[2] = 1;
		responseExpected[IPConnection.unsignedByte(FUNCTION_WRITE_LINE)] = RESPONSE_EXPECTED_FLAG_FALSE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_CLEAR_DISPLAY)] = RESPONSE_EXPECTED_FLAG_FALSE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_BACKLIGHT_ON)] = RESPONSE_EXPECTED_FLAG_FALSE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_BACKLIGHT_OFF)] = RESPONSE_EXPECTED_FLAG_FALSE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_IS_BACKLIGHT_ON)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_SET_CONFIG)] = RESPONSE_EXPECTED_FLAG_FALSE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_GET_CONFIG)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_IS_BUTTON_PRESSED)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_SET_CUSTOM_CHARACTER)] = RESPONSE_EXPECTED_FLAG_FALSE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_GET_CUSTOM_CHARACTER)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_GET_IDENTITY)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;

		callbacks[CALLBACK_BUTTON_PRESSED] = new IPConnection.DeviceCallbackListener() {
			public void callback(byte[] packet) {
				ByteBuffer bb = ByteBuffer.wrap(packet, 8, packet.length - 8);
				bb.order(ByteOrder.LITTLE_ENDIAN);

				short button = IPConnection.unsignedByte(bb.get());

				for (ButtonPressedListener listener: listenerButtonPressed) {
					listener.buttonPressed(button);
				}
			}
		};

		callbacks[CALLBACK_BUTTON_RELEASED] = new IPConnection.DeviceCallbackListener() {
			public void callback(byte[] packet) {
				ByteBuffer bb = ByteBuffer.wrap(packet, 8, packet.length - 8);
				bb.order(ByteOrder.LITTLE_ENDIAN);

				short button = IPConnection.unsignedByte(bb.get());

				for (ButtonReleasedListener listener: listenerButtonReleased) {
					listener.buttonReleased(button);
				}
			}
		};
	}

	/**
	 * Writes text to a specific line (0 to 1) with a specific position
	 * (0 to 15). The text can have a maximum of 16 characters.
	 * 
	 * For example: (0, 5, "Hello") will write *Hello* in the middle of the
	 * first line of the display.
	 * 
	 * The display uses a special charset that includes all ASCII characters except
	 * backslash and tilde. The LCD charset also includes several other non-ASCII characters, see
	 * the `charset specification &lt;https://github.com/Tinkerforge/lcd-16x2-bricklet/raw/master/datasheets/standard_charset.pdf&gt;`__
	 * for details. The Unicode example above shows how to specify non-ASCII characters
	 * and how to translate from Unicode to the LCD charset.
	 */
	public void writeLine(short line, short position, String text) throws TinkerforgeException {
		ByteBuffer bb = ipcon.createRequestPacket((byte)26, FUNCTION_WRITE_LINE, this);

		bb.put((byte)line);
		bb.put((byte)position);
		for (int i = 0; i < 16; i++) {
			try {
				bb.put((byte)text.charAt(i));
			} catch(Exception e) {
				bb.put((byte)0);
			}
		}

		sendRequest(bb.array());
	}

	/**
	 * Deletes all characters from the display.
	 */
	public void clearDisplay() throws TinkerforgeException {
		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_CLEAR_DISPLAY, this);


		sendRequest(bb.array());
	}

	/**
	 * Turns the backlight on.
	 */
	public void backlightOn() throws TinkerforgeException {
		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_BACKLIGHT_ON, this);


		sendRequest(bb.array());
	}

	/**
	 * Turns the backlight off.
	 */
	public void backlightOff() throws TinkerforgeException {
		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_BACKLIGHT_OFF, this);


		sendRequest(bb.array());
	}

	/**
	 * Returns *true* if the backlight is on and *false* otherwise.
	 */
	public boolean isBacklightOn() throws TinkerforgeException {
		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_IS_BACKLIGHT_ON, this);


		byte[] response = sendRequest(bb.array());

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		boolean backlight = (bb.get()) != 0;

		return backlight;
	}

	/**
	 * Configures if the cursor (shown as "_") should be visible and if it
	 * should be blinking (shown as a blinking block). The cursor position
	 * is one character behind the the last text written with
	 * {@link BrickletLCD16x2#writeLine(short, short, String)}.
	 * 
	 * The default is (false, false).
	 */
	public void setConfig(boolean cursor, boolean blinking) throws TinkerforgeException {
		ByteBuffer bb = ipcon.createRequestPacket((byte)10, FUNCTION_SET_CONFIG, this);

		bb.put((byte)(cursor ? 1 : 0));
		bb.put((byte)(blinking ? 1 : 0));

		sendRequest(bb.array());
	}

	/**
	 * Returns the configuration as set by {@link BrickletLCD16x2#setConfig(boolean, boolean)}.
	 */
	public Config getConfig() throws TinkerforgeException {
		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_CONFIG, this);


		byte[] response = sendRequest(bb.array());

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		Config obj = new Config();
		obj.cursor = (bb.get()) != 0;
		obj.blinking = (bb.get()) != 0;

		return obj;
	}

	/**
	 * Returns *true* if the button (0 to 2) is pressed.
	 * 
	 * If you want to react on button presses and releases it is recommended to use the
	 * {@link BrickletLCD16x2.ButtonPressedListener} and {@link BrickletLCD16x2.ButtonReleasedListener} listeners.
	 */
	public boolean isButtonPressed(short button) throws TinkerforgeException {
		ByteBuffer bb = ipcon.createRequestPacket((byte)9, FUNCTION_IS_BUTTON_PRESSED, this);

		bb.put((byte)button);

		byte[] response = sendRequest(bb.array());

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		boolean pressed = (bb.get()) != 0;

		return pressed;
	}

	/**
	 * The LCD 16x2 Bricklet can store up to 8 custom characters. The characters
	 * consist of 5x8 pixels and can be addressed with the index 0-7. To describe
	 * the pixels, the first 5 bits of 8 bytes are used. For example, to make
	 * a custom character "H", you should transfer the following:
	 * 
	 * * ``character[0] = 0b00010001`` (decimal value 17)
	 * * ``character[1] = 0b00010001`` (decimal value 17)
	 * * ``character[2] = 0b00010001`` (decimal value 17)
	 * * ``character[3] = 0b00011111`` (decimal value 31)
	 * * ``character[4] = 0b00010001`` (decimal value 17)
	 * * ``character[5] = 0b00010001`` (decimal value 17)
	 * * ``character[6] = 0b00010001`` (decimal value 17)
	 * * ``character[7] = 0b00000000`` (decimal value 0)
	 * 
	 * The characters can later be written with {@link BrickletLCD16x2#writeLine(short, short, String)} by using the
	 * characters with the byte representation 8 to 15.
	 * 
	 * You can play around with the custom characters in Brick Viewer since
	 * version 2.0.1.
	 * 
	 * Custom characters are stored by the LCD in RAM, so they have to be set
	 * after each startup.
	 * 
	 * .. versionadded:: 2.0.1$nbsp;(Plugin)
	 */
	public void setCustomCharacter(short index, short[] character) throws TinkerforgeException {
		ByteBuffer bb = ipcon.createRequestPacket((byte)17, FUNCTION_SET_CUSTOM_CHARACTER, this);

		bb.put((byte)index);
		for (int i = 0; i < 8; i++) {
			bb.put((byte)character[i]);
		}

		sendRequest(bb.array());
	}

	/**
	 * Returns the custom character for a given index, as set with
	 * {@link BrickletLCD16x2#setCustomCharacter(short, short[])}.
	 * 
	 * .. versionadded:: 2.0.1$nbsp;(Plugin)
	 */
	public short[] getCustomCharacter(short index) throws TinkerforgeException {
		ByteBuffer bb = ipcon.createRequestPacket((byte)9, FUNCTION_GET_CUSTOM_CHARACTER, this);

		bb.put((byte)index);

		byte[] response = sendRequest(bb.array());

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		short[] character = new short[8];
		for (int i = 0; i < 8; i++) {
			character[i] = IPConnection.unsignedByte(bb.get());
		}

		return character;
	}

	/**
	 * Returns the UID, the UID where the Bricklet is connected to,
	 * the position, the hardware and firmware version as well as the
	 * device identifier.
	 * 
	 * The position can be 'a', 'b', 'c' or 'd'.
	 * 
	 * The device identifier numbers can be found :ref:`here &lt;device_identifier&gt;`.
	 * |device_identifier_constant|
	 */
	public Identity getIdentity() throws TinkerforgeException {
		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_IDENTITY, this);


		byte[] response = sendRequest(bb.array());

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		Identity obj = new Identity();
		obj.uid = IPConnection.string(bb, 8);
		obj.connectedUid = IPConnection.string(bb, 8);
		obj.position = (char)(bb.get());
		for (int i = 0; i < 3; i++) {
			obj.hardwareVersion[i] = IPConnection.unsignedByte(bb.get());
		}
		for (int i = 0; i < 3; i++) {
			obj.firmwareVersion[i] = IPConnection.unsignedByte(bb.get());
		}
		obj.deviceIdentifier = IPConnection.unsignedShort(bb.getShort());

		return obj;
	}

	/**
	 * Adds a ButtonPressed listener.
	 */
	public void addButtonPressedListener(ButtonPressedListener listener) {
		listenerButtonPressed.add(listener);
	}

	/**
	 * Removes a ButtonPressed listener.
	 */
	public void removeButtonPressedListener(ButtonPressedListener listener) {
		listenerButtonPressed.remove(listener);
	}

	/**
	 * Adds a ButtonReleased listener.
	 */
	public void addButtonReleasedListener(ButtonReleasedListener listener) {
		listenerButtonReleased.add(listener);
	}

	/**
	 * Removes a ButtonReleased listener.
	 */
	public void removeButtonReleasedListener(ButtonReleasedListener listener) {
		listenerButtonReleased.remove(listener);
	}

    private final Logger logger = LoggerFactory.getLogger(BrickletLCD16x2.class);
    private final static Logger static_logger = LoggerFactory.getLogger(BrickletLCD16x2.class);

    @Override
    public void initialize(org.eclipse.smarthome.config.core.Configuration config, Function<String, org.eclipse.smarthome.config.core.Configuration> getChannelConfigFn, BiConsumer<String, org.eclipse.smarthome.core.types.State> updateStateFn, BiConsumer<String, String> triggerChannelFn) throws TinkerforgeException {
        BrickletLCD16x2Config cfg = (BrickletLCD16x2Config) config.as(BrickletLCD16x2Config.class);
        this.addButtonPressedListener((button) -> {if(button == 0) {triggerChannelFn.accept("LCD16x2Button0", transformLCD16x2Button0Callback0(button, cfg));}});
		this.addButtonReleasedListener((button) -> {if(button == 0) {triggerChannelFn.accept("LCD16x2Button0", transformLCD16x2Button0Callback1(button, cfg));}});
		this.addButtonPressedListener((button) -> {if(button == 1) {triggerChannelFn.accept("LCD16x2Button1", transformLCD16x2Button1Callback0(button, cfg));}});
		this.addButtonReleasedListener((button) -> {if(button == 1) {triggerChannelFn.accept("LCD16x2Button1", transformLCD16x2Button1Callback1(button, cfg));}});
		this.addButtonPressedListener((button) -> {if(button == 2) {triggerChannelFn.accept("LCD16x2Button2", transformLCD16x2Button2Callback0(button, cfg));}});
		this.addButtonReleasedListener((button) -> {if(button == 2) {triggerChannelFn.accept("LCD16x2Button2", transformLCD16x2Button2Callback1(button, cfg));}});
        this.setConfig(cfg.showCursor, cfg.showBlinkingCursor);
		{
		BrickletLCD16x2TextConfig channelCfg = getChannelConfigFn.apply("LCD16x2Text").as(BrickletLCD16x2TextConfig.class);
		
		}
		{
		BrickletLCD16x2ClearDisplayConfig channelCfg = getChannelConfigFn.apply("LCD16x2ClearDisplay").as(BrickletLCD16x2ClearDisplayConfig.class);
		
		}
		{
		BrickletLCD16x2BacklightConfig channelCfg = getChannelConfigFn.apply("LCD16x2Backlight").as(BrickletLCD16x2BacklightConfig.class);
		
		}
		{
		
		}
		{
		
		}
		{
		
		}
    }

    @Override
    public void dispose(org.eclipse.smarthome.config.core.Configuration config) throws TinkerforgeException {
        BrickletLCD16x2Config cfg = (BrickletLCD16x2Config) config.as(BrickletLCD16x2Config.class);
        this.listenerButtonPressed.clear();
		this.listenerButtonReleased.clear();
		this.listenerButtonPressed.clear();
		this.listenerButtonReleased.clear();
		this.listenerButtonPressed.clear();
		this.listenerButtonReleased.clear();
        
		
		
		
		
		
		
    }

    @Override
    public List<String> getEnabledChannels(org.eclipse.smarthome.config.core.Configuration config) throws TinkerforgeException{
        BrickletLCD16x2Config cfg = (BrickletLCD16x2Config) config.as(BrickletLCD16x2Config.class);
        List<String> result = new ArrayList<String>();
        result.add("LCD16x2Text");
		result.add("LCD16x2ClearDisplay");
		result.add("LCD16x2Backlight");
		result.add("LCD16x2Button0");
		result.add("LCD16x2Button1");
		result.add("LCD16x2Button2");
        return result;
    }

    public static ChannelType getChannelType(ChannelTypeUID channelTypeUID) {
        switch(channelTypeUID.getId()) {
            case "LCD16x2Text":
                return ChannelTypeBuilder.state(new ChannelTypeUID("tinkerforge", "LCD16x2Text"), "Text", "String").withConfigDescriptionURI(URI.create("channel-type:tinkerforge:LCD16x2Text")).withDescription("Text to display on the LCD. Command format is [line],[position],[text].<br/><br/>Additional ',' are handled as part of the text. Unicode characters are converted to the LCD character set if possible. Additionally you can use \\x[two hex digits] to use a character of the LCD character set directly.").build();
            case "LCD16x2ClearDisplay":
                return ChannelTypeBuilder.state(new ChannelTypeUID("tinkerforge", "LCD16x2ClearDisplay"), "Clear Display", "String").withConfigDescriptionURI(URI.create("channel-type:tinkerforge:LCD16x2ClearDisplay")).withDescription("Deletes all characters from the display.")
.withCommandDescription(CommandDescriptionBuilder.create().withCommandOption(new CommandOption("CLEAR", "Clear")).build()).build();
            case "LCD16x2Backlight":
                return ChannelTypeBuilder.state(new ChannelTypeUID("tinkerforge", "LCD16x2Backlight"), "Backlight", "Switch").withConfigDescriptionURI(URI.create("channel-type:tinkerforge:LCD16x2Backlight")).withDescription("Toggles the LCD's backlight").build();
            default:
                static_logger.debug("Unknown channel type ID {}", channelTypeUID.getId());
                break;
        }

        return null;
    }

    public static ThingType getThingType(ThingTypeUID thingTypeUID) {
        return ThingTypeBuilder.instance(thingTypeUID, "Tinkerforge LCD 16x2 Bricklet").isListed(false).withSupportedBridgeTypeUIDs(Arrays.asList(TinkerforgeBindingConstants.THING_TYPE_BRICK_DAEMON.getId())).withConfigDescriptionURI(URI.create("thing-type:tinkerforge:" + thingTypeUID.getId())).withDescription("16x2 character alphanumeric display with blue backlight").withChannelDefinitions(Arrays.asList(new ChannelDefinitionBuilder("LCD16x2Text", new ChannelTypeUID("tinkerforge", "LCD16x2Text")).build(), new ChannelDefinitionBuilder("LCD16x2ClearDisplay", new ChannelTypeUID("tinkerforge", "LCD16x2ClearDisplay")).build(), new ChannelDefinitionBuilder("LCD16x2Backlight", new ChannelTypeUID("tinkerforge", "LCD16x2Backlight")).build(), new ChannelDefinitionBuilder("LCD16x2Button0", new ChannelTypeUID("system", "rawbutton")).withLabel("Button 0").build(), new ChannelDefinitionBuilder("LCD16x2Button1", new ChannelTypeUID("system", "rawbutton")).withLabel("Button 1").build(), new ChannelDefinitionBuilder("LCD16x2Button2", new ChannelTypeUID("system", "rawbutton")).withLabel("Button 2").build())).build();
    }

    public static ConfigDescription getConfigDescription(URI uri) {
        switch(uri.toASCIIString()) {
            case "thing-type:tinkerforge:lcd16x2":
                return new ConfigDescription(uri, Arrays.asList(ConfigDescriptionParameterBuilder.create("showCursor", Type.BOOLEAN).withDefault("false").withDescription("Configures if the cursor (shown as '_') should be visible. The cursor position is one character behind the the last text written.").withLabel("Show Cursor").build(), ConfigDescriptionParameterBuilder.create("showBlinkingCursor", Type.BOOLEAN).withDefault("false").withDescription("Configures if the blinking cursor (shown as a blinking block) should be visible. The cursor position is one character behind the the last text written.").withLabel("Show Blinking Cursor").build()), Arrays.asList(new ConfigDescriptionParameterGroup("update_intervals", "null", true, "Update Intervals", "Update Intervals")));
            case "channel-type:tinkerforge:LCD16x2Text":
                return new ConfigDescription(uri, Arrays.asList(ConfigDescriptionParameterBuilder.create("updateInterval", Type.INTEGER).withDefault("1000").withDescription("Specifies the update interval in milliseconds. A value of 0 disables automatic updates.").withGroupName("update_intervals").withLabel("Update Interval").withUnit("ms").build()));
            case "channel-type:tinkerforge:LCD16x2ClearDisplay":
                return new ConfigDescription(uri, Arrays.asList());
            case "channel-type:tinkerforge:LCD16x2Backlight":
                return new ConfigDescription(uri, Arrays.asList(ConfigDescriptionParameterBuilder.create("updateInterval", Type.INTEGER).withDefault("1000").withDescription("Specifies the update interval in milliseconds. A value of 0 disables automatic updates.").withGroupName("update_intervals").withLabel("Update Interval").withUnit("ms").build()));
            default:
                static_logger.debug("Unknown config description URI {}", uri.toASCIIString());
                break;
        }
        return null;
    }

        @Override
    public void refreshValue(String value, org.eclipse.smarthome.config.core.Configuration config, org.eclipse.smarthome.config.core.Configuration channelConfig, BiConsumer<String, org.eclipse.smarthome.core.types.State> updateStateFn, BiConsumer<String, String> triggerChannelFn) throws TinkerforgeException {
        BrickletLCD16x2Config cfg = (BrickletLCD16x2Config) config.as(BrickletLCD16x2Config.class);
        switch(value) {
            case "LCD16x2Text":
               return;
            case "LCD16x2ClearDisplay":
               return;
            case "LCD16x2Backlight": {
                   BrickletLCD16x2BacklightConfig channelCfg = channelConfig.as(BrickletLCD16x2BacklightConfig.class);
                   updateStateFn.accept(value, transformLCD16x2BacklightGetter0(this.isBacklightOn(), cfg));
                   return;
               }
            case "LCD16x2Button0":
                   triggerChannelFn.accept(value, transformLCD16x2Button0Getter0(this.isButtonPressed((short)(0)), cfg));
                   return;
            case "LCD16x2Button1":
                   triggerChannelFn.accept(value, transformLCD16x2Button1Getter0(this.isButtonPressed((short)(1)), cfg));
                   return;
            case "LCD16x2Button2":
                   triggerChannelFn.accept(value, transformLCD16x2Button2Getter0(this.isButtonPressed((short)(2)), cfg));
                   return;
            default:
                logger.warn("Refresh for unknown channel {}", value);
                break;
        }
    }
    

        @Override
    public List<SetterRefresh> handleCommand(org.eclipse.smarthome.config.core.Configuration config, org.eclipse.smarthome.config.core.Configuration channelConfig, String channel, Command command) throws TinkerforgeException {
        List<SetterRefresh> result = Collections.emptyList();
        BrickletLCD16x2Config cfg = (BrickletLCD16x2Config) config.as(BrickletLCD16x2Config.class);
        switch(channel) {
            case "LCD16x2Text":
                if (command instanceof StringType) {
                    BrickletLCD16x2TextConfig channelCfg = channelConfig.as(BrickletLCD16x2TextConfig.class);
                    StringType cmd = (StringType) command;
                    this.writeLine(Helper.parseDisplayCommandLine(cmd.toString(), logger), Helper.parseDisplayCommandPosition(cmd.toString(), logger), Helper.parseDisplayCommandText(cmd.toString(), logger));
                    
                } else {
                    logger.warn("Command type {} not supported for channel {}. Please use a StringType.", command.getClass().getName(), channel);
                }
                break;
            case "LCD16x2ClearDisplay":
                if (command instanceof StringType) {
                    BrickletLCD16x2ClearDisplayConfig channelCfg = channelConfig.as(BrickletLCD16x2ClearDisplayConfig.class);
                    StringType cmd = (StringType) command;
                    this.clearDisplay();
                    
                } else {
                    logger.warn("Command type {} not supported for channel {}. Please use a StringType.", command.getClass().getName(), channel);
                }
                break;
            case "LCD16x2Backlight":
                if (command instanceof OnOffType) {
                    BrickletLCD16x2BacklightConfig channelCfg = channelConfig.as(BrickletLCD16x2BacklightConfig.class);
                    OnOffType cmd = (OnOffType) command;
                    if(cmd == OnOffType.ON) {
    this.backlightOn();
}
                    if(cmd == OnOffType.OFF) {
    this.backlightOff();
}
                    
                } else {
                    logger.warn("Command type {} not supported for channel {}. Please use a OnOffType.", command.getClass().getName(), channel);
                }
                break;
            default:
                logger.warn("Command for unknown channel {}", channel);
        }
        return result;
    }

        private String transformLCD16x2Button0Callback0(short button, BrickletLCD16x2Config cfg) {
        return CommonTriggerEvents.PRESSED;
    }
	    private String transformLCD16x2Button0Callback1(short button, BrickletLCD16x2Config cfg) {
        return CommonTriggerEvents.RELEASED;
    }
	    private String transformLCD16x2Button1Callback0(short button, BrickletLCD16x2Config cfg) {
        return CommonTriggerEvents.PRESSED;
    }
	    private String transformLCD16x2Button1Callback1(short button, BrickletLCD16x2Config cfg) {
        return CommonTriggerEvents.RELEASED;
    }
	    private String transformLCD16x2Button2Callback0(short button, BrickletLCD16x2Config cfg) {
        return CommonTriggerEvents.PRESSED;
    }
	    private String transformLCD16x2Button2Callback1(short button, BrickletLCD16x2Config cfg) {
        return CommonTriggerEvents.RELEASED;
    }
	    private org.eclipse.smarthome.core.types.State transformLCD16x2BacklightGetter0(boolean value, BrickletLCD16x2Config cfg) {
        return value ? OnOffType.ON : OnOffType.OFF;
    }
	    private String transformLCD16x2Button0Getter0(boolean value, BrickletLCD16x2Config cfg) {
        return value ? CommonTriggerEvents.PRESSED : CommonTriggerEvents.RELEASED;
    }
	    private String transformLCD16x2Button1Getter0(boolean value, BrickletLCD16x2Config cfg) {
        return value ? CommonTriggerEvents.PRESSED : CommonTriggerEvents.RELEASED;
    }
	    private String transformLCD16x2Button2Getter0(boolean value, BrickletLCD16x2Config cfg) {
        return value ? CommonTriggerEvents.PRESSED : CommonTriggerEvents.RELEASED;
    }
}
